#include "stdafx.h"
#include "colors.h"


/****************************************************************************
*                        PriorityColors::GetTextColor
* Inputs:
*       int pri: Priority class
* Result: COLORREF
*       The text color for the priority class
****************************************************************************/

/* static */ COLORREF PriorityColors::GetTextColor(int pri)
    {
     switch(pri)
        { /* pri */
         case THREAD_PRIORITY_IDLE:
            return RGB(255, 255, 255);
         case THREAD_PRIORITY_LOWEST:
            return RGB(255, 255, 255);
         case THREAD_PRIORITY_BELOW_NORMAL:
            return RGB(0, 0, 0);
         case THREAD_PRIORITY_NORMAL:
            return RGB(0, 0, 0);
         case THREAD_PRIORITY_ABOVE_NORMAL:
            return RGB(0, 0, 0);
         case THREAD_PRIORITY_HIGHEST:
            return RGB(0, 0, 0);
         case THREAD_PRIORITY_TIME_CRITICAL:
            return RGB(255, 255, 255);
        } /* pri */
     ASSERT(FALSE);
     return RGB(0, 0, 0);
    } // PriorityColors::GetTextColor

/****************************************************************************
*                         PriorityColors::GetBkColor
* Inputs:
*       int pri: Desired priority
* Result: COLORREF
*       The color for the background
****************************************************************************/

/* static */ COLORREF PriorityColors::GetBkColor(int pri)
    {
     switch(pri)
        { /* pri */
         case THREAD_PRIORITY_IDLE:
            return RGB(0,0,0);
         case THREAD_PRIORITY_LOWEST:
            return RGB(0, 0, 255);
         case THREAD_PRIORITY_BELOW_NORMAL:
            return RGB(0, 255, 0);
         case THREAD_PRIORITY_NORMAL:
            return RGB(255, 255, 0);
         case THREAD_PRIORITY_ABOVE_NORMAL:
            return RGB(255, 153, 0);
         case THREAD_PRIORITY_HIGHEST:
            return RGB(255, 153, 204);
         case THREAD_PRIORITY_TIME_CRITICAL:
            return RGB(255, 0, 0);
        } /* pri */
     ASSERT(FALSE);
     return RGB(255, 255, 255);
    } // PriorityColors::GetBkColor
