#pragma once

#include "maxthreads.h"
#include "InfoDisplay.h"
#include "GraphInfo.h"
#include "ThreadInfo.h"

// CGraph

class CGraph : public CStatic
{
        DECLARE_DYNAMIC(CGraph)

public:
        CGraph();
        virtual ~CGraph();
        void Clear();
        void AddPoint(INT_PTR index, int priority, CPoint pt);
        void Plot();
        HWND GetProcess() { return wnd; }
        void SetProcess(HWND w) { wnd = w; }
        BOOL Create(const CRect & r, CWnd * parent);
        void SetGraphInfo(GRAPHINFO * g) { graphInfo = *g; }
        void SetThreadInfo(THREADINFO * info);
protected:
        HWND wnd;
        static int GetFuzz(CDC & dc);
        CInfoDisplay * info;
        GRAPHINFO graphInfo;
        void SetInfoWindow(CPoint point, const CString & text, BOOL visible);
        BOOL SetMappingMode(CDC & dc);
        BOOL PositionOnMonitor(CPoint target);

        class LineInfo {
            public:
               int priority;
               CArray<CPoint, CPoint&> points;
               void Plot(CDC & dc);
               BOOL InBoundingRgn(CPoint pt, int fuzz);
               void ResetBoundingRgn();
               void SetThreadInfo(THREADINFO * p) { info = *p; }
               CString GetText() { return info.GetText(); }
            protected:
               THREADINFO info;
               CRgn boundingRgn;
               BOOL ConstructRegion(int fuzz);
        };

        LineInfo lines[MAX_THREADS];

        BOOL CanPlot;
        CPoint BB; // bounding box (assume 0,0 for left end)
        
        DECLARE_MESSAGE_MAP()
protected:
    afx_msg void OnPaint();
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    afx_msg void OnDestroy();
    afx_msg void OnMouseMove(UINT nFlags, CPoint point);
    afx_msg LRESULT OnMouseLeave(WPARAM, LPARAM);
    afx_msg void OnSize(UINT nType, int cx, int cy);
};


