#include "stdafx.h"
#include "resource.h"
#include "ThreadInfo.h"


/****************************************************************************
*                             THREADINFO::GetText
* Result: CString
*       A printable string
* Notes: 
*       Thread #: n
*       Thread Priority: <name>
*       Processor Affinity Mask: %p (0, 1, 2, 3, 4, 5, 6, 7)
****************************************************************************/

CString THREADINFO::GetText()
    {
     CString result;

     CString s;
     // Thread #: " %d
     s.LoadString(IDS_THREAD_CAPTION_NUMBER);
     result = s;
     s.Format(_T("%d"), index + 1);
     result += s;
     result += _T("\n");

     s.LoadString(IDS_THREAD_CAPTION_THREAD_PRIORITY);
     result += s;
     result += priority;
     result += _T("\n");
     
     s.LoadString(IDS_THREAD_CAPTION_PROCESSOR_AFFINITY_MASK);
     result += s;
     s.Format(_T("%p"), affinity);
     result += s;

     if(affinity != 0)
        { /* show affinities */
         result += _T(" (");
         CString sep;
         for(int i = 0; i < 8 * sizeof(DWORD_PTR); i++)
            { /* bits decode */
             if(affinity & (1 << i))
                { /* has bit */
                 CString d;
                 d.Format(_T("%d"), i);
                 result += sep + d;
                 sep = _T(" ");
                } /* has bit */
            } /* bits decode */
         result += _T(")");
        } /* show affinities */
     return result;
    } // THREADINFO::GetText
