// affinityDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "affinityDlg.h"
#include "Unavailable.h"
#include "Colors.h"
#include "toClip.h"
#include "RegVars.h"
#include "Registry.h"
#include "dim.h"
#include "iterations.h"
#include "NewConfigurationName.h"
#include "ProcessNotification.h"
#include "CopyDataTypes.h"
#include "GraphInfo.h"
#include "ThreadInfo.h"

#pragma data_seg(".shared")
HWND MasterController = NULL; // shared data object
#pragma data_seg()
#pragma comment(linker, "/section:.shared,rws")

#define CONFIGURATION_NEW ((DWORD)-1)

//****************
// Startup Failure
//****************
#define STARTUP_FAILURE_HWND  ((HWND)-2)

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

static const IDData IterationTable[] = {
   { IDS_SHORTEST,     DEFAULT_ITERATIONS / 10},
   { IDS_SHORTER,      DEFAULT_ITERATIONS / 5 },
   { IDS_SHORT,        DEFAULT_ITERATIONS / 2 },
   { IDS_REGULAR,      DEFAULT_ITERATIONS},
   { IDS_LONG,         DEFAULT_ITERATIONS * 2},
   { IDS_LONGER,       DEFAULT_ITERATIONS * 5},
   { IDS_LONGEST,      DEFAULT_ITERATIONS * 10},
   { IDS_UNBELIEVABLE, DEFAULT_ITERATIONS * 100}, // 1,000,000,000 in release mode
   {0, 0} // EOT
};



/****************************************************************************
*                               UWM_ANY_RUNNING
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: (LRESULT)(BOOL)
*       TRUE if any thread is running
****************************************************************************/

static UINT UWM_ANY_RUNNING = ::RegisterWindowMessage(_T("UWM_ANY_RUNNING-{F0F0BEA0-F2EA-491f-A99A-B5388E1DBAE6}"));

/****************************************************************************
*                               UWM_CONFIGURATION_CHANGE
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
****************************************************************************/

static UINT UWM_CONFIGURATION_CHANGE = ::RegisterWindowMessage(_T("UWM_CONFIGURATION_CHANGE-{F0F0BEA0-F2EA-491f-A99A-B5388E1DBAE6}"));

/****************************************************************************
*                                 UWM_SETPOS
* Inputs:
*       WPARAM: (WPARAM)(CaffinityDlg::CThreadControl *)
*       LPARAM: (LPARAM)(POSINFO *)
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sets the progress bar position
****************************************************************************/

static UINT UWM_SETPOS = ::RegisterWindowMessage(_T("UWM_SETPOS-{F0F0BEA0-F2EA-491f-A99A-B5388E1DBAE6}"));


/****************************************************************************
*                                   UWM_LOG
* Inputs:
*       WPARAM: (WPARAM)(TraceEvent *)
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Logs the message
****************************************************************************/

static UINT UWM_LOG = ::RegisterWindowMessage(_T("UWM_LOG-{F0F0BEA0-F2EA-491f-A99A-B5388E1DBAE6}"));

/****************************************************************************
*                             UWM_THREAD_STOPPED
* Inputs:
*       WPARAM: (WPARAM)(CaffinityDlg::CThreadControl *)
*       LPARAM: Time (wall clock time in ms) the thread has run
* Result: LRESULT
*       Logically void, 0, always  
* Effect: 
*       Notifies the window that the thread has stopped
****************************************************************************/

static UINT UWM_THREAD_STOPPED = ::RegisterWindowMessage(_T("UWM_THREAD_STOPPED-{F0F0BEA0-F2EA-491f-A99A-B5388E1DBAE6}"));


/****************************************************************************
*                             UWM_STARTUP_FAILURE
* Inputs:
*       WPARAM: unused
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Notifies the instance that it can't be a secondary
****************************************************************************/

static UINT UWM_STARTUP_FAILURE = ::RegisterWindowMessage(_T("UWM_STARTUP_FAILURE-{595BA37C-B700-4835-8854-9EED5A6A0896}"));


/****************************************************************************
*                             UWM_REQUEST_PLOT
* Inputs:
*       WPARAM: unused
*       LPARAM: (LPARAM)(HWND) The window handle of the process requesting the plot
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Notifies the master application that this process has finished
****************************************************************************/

static UINT UWM_REQUEST_PLOT = ::RegisterWindowMessage(_T("UWM_REQUEST_PLOT-{595BA37C-B700-4835-8854-9EED5A6A0896}"));


/****************************************************************************
*                                UWM_CLICK_ALL
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Causes all the threads to be created
****************************************************************************/

static UINT UWM_CLICK_ALL = ::RegisterWindowMessage(_T("UWM_CLICK_ALL-{595BA37C-B700-4835-8854-9EED5A6A0896}"));


/****************************************************************************
*                                 UWM_RUN_ALL
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Invokes the RunAll option remotely
****************************************************************************/

static UINT UWM_RUN_ALL = ::RegisterWindowMessage(_T("UWM_RUN_ALL-{595BA37C-B700-4835-8854-9EED5A6A0896}"));

/****************************************************************************
*                                 UWM_SETUP_COMPLETE
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Invokes the RunAll option remotely
****************************************************************************/

static UINT UWM_SETUP_COMPLETE = ::RegisterWindowMessage(_T("UWM_SETUP_COMPLETE-{595BA37C-B700-4835-8854-9EED5A6A0896}"));

/****************************************************************************
*                                  CAboutDlg
****************************************************************************/

// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
        CAboutDlg();

// Dialog Data
        enum { IDD = IDD_ABOUTBOX };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
        DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
        CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

/****************************************************************************
*                         CaffinityDlg::CaffinityDlg
* Effect: 
*       Constructor
****************************************************************************/

CaffinityDlg::CaffinityDlg(CWnd* pParent /*=NULL*/)
        : CDialog(CaffinityDlg::IDD, pParent)
{
        m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
        threadcount = 0;
        OffsetCount = 0;
        CreationMutex = NULL;
        Primary = TRUE;
        closing = FALSE;
}

/****************************************************************************
*                        CaffinityDlg::DoDataExchange
* Inputs:
*       CDataExchange * pDX:
* Result: void
*       
* Effect: 
*       Binds the controls
* Notes:
*       This is massively hand-edited to bind the controls in each
*       individual ThreadInfo object
****************************************************************************/

void CaffinityDlg::DoDataExchange(CDataExchange* pDX)
{
CDialog::DoDataExchange(pDX);
DDX_Control(pDX, IDC_THREAD1,   ThreadInfo[0].c_ThreadHandle);
DDX_Control(pDX, IDC_ID1,       ThreadInfo[0].c_ThreadID);
DDX_Control(pDX, IDC_GO1,       ThreadInfo[0].c_Go);
DDX_Control(pDX, IDC_PRI1,      ThreadInfo[0].c_Priority);
DDX_Control(pDX, IDC_AFF1_7,    ThreadInfo[0].c_Affinity[7]);
DDX_Control(pDX, IDC_AFF1_6,    ThreadInfo[0].c_Affinity[6]);
DDX_Control(pDX, IDC_AFF1_5,    ThreadInfo[0].c_Affinity[5]);
DDX_Control(pDX, IDC_AFF1_4,    ThreadInfo[0].c_Affinity[4]);
DDX_Control(pDX, IDC_AFF1_3,    ThreadInfo[0].c_Affinity[3]);
DDX_Control(pDX, IDC_AFF1_2,    ThreadInfo[0].c_Affinity[2]);
DDX_Control(pDX, IDC_AFF1_1,    ThreadInfo[0].c_Affinity[1]);
DDX_Control(pDX, IDC_AFF1_0,    ThreadInfo[0].c_Affinity[0]);
DDX_Control(pDX, IDC_MASK1,     ThreadInfo[0].c_Mask);
DDX_Control(pDX, IDC_PROGRESS1, ThreadInfo[0].c_Progress);
DDX_Control(pDX, IDC_TIME1,     ThreadInfo[0].c_Time);

DDX_Control(pDX, IDC_THREAD2,   ThreadInfo[1].c_ThreadHandle);
DDX_Control(pDX, IDC_ID2,       ThreadInfo[1].c_ThreadID);
DDX_Control(pDX, IDC_GO2,       ThreadInfo[1].c_Go);
DDX_Control(pDX, IDC_PRI2,      ThreadInfo[1].c_Priority);
DDX_Control(pDX, IDC_AFF2_7,    ThreadInfo[1].c_Affinity[7]);
DDX_Control(pDX, IDC_AFF2_6,    ThreadInfo[1].c_Affinity[6]);
DDX_Control(pDX, IDC_AFF2_5,    ThreadInfo[1].c_Affinity[5]);
DDX_Control(pDX, IDC_AFF2_4,    ThreadInfo[1].c_Affinity[4]);
DDX_Control(pDX, IDC_AFF2_3,    ThreadInfo[1].c_Affinity[3]);
DDX_Control(pDX, IDC_AFF2_2,    ThreadInfo[1].c_Affinity[2]);
DDX_Control(pDX, IDC_AFF2_1,    ThreadInfo[1].c_Affinity[1]);
DDX_Control(pDX, IDC_AFF2_0,    ThreadInfo[1].c_Affinity[0]);
DDX_Control(pDX, IDC_MASK2,     ThreadInfo[1].c_Mask);
DDX_Control(pDX, IDC_PROGRESS2, ThreadInfo[1].c_Progress);
DDX_Control(pDX, IDC_TIME2,     ThreadInfo[1].c_Time);


DDX_Control(pDX, IDC_THREAD3,   ThreadInfo[2].c_ThreadHandle);
DDX_Control(pDX, IDC_ID3,       ThreadInfo[2].c_ThreadID);
DDX_Control(pDX, IDC_GO3,       ThreadInfo[2].c_Go);
DDX_Control(pDX, IDC_PRI3,      ThreadInfo[2].c_Priority);
DDX_Control(pDX, IDC_AFF3_7,    ThreadInfo[2].c_Affinity[7]);
DDX_Control(pDX, IDC_AFF3_6,    ThreadInfo[2].c_Affinity[6]);
DDX_Control(pDX, IDC_AFF3_5,    ThreadInfo[2].c_Affinity[5]);
DDX_Control(pDX, IDC_AFF3_4,    ThreadInfo[2].c_Affinity[4]);
DDX_Control(pDX, IDC_AFF3_3,    ThreadInfo[2].c_Affinity[3]);
DDX_Control(pDX, IDC_AFF3_2,    ThreadInfo[2].c_Affinity[2]);
DDX_Control(pDX, IDC_AFF3_1,    ThreadInfo[2].c_Affinity[1]);
DDX_Control(pDX, IDC_AFF3_0,    ThreadInfo[2].c_Affinity[0]);
DDX_Control(pDX, IDC_MASK3,     ThreadInfo[2].c_Mask);
DDX_Control(pDX, IDC_PROGRESS3, ThreadInfo[2].c_Progress);
DDX_Control(pDX, IDC_TIME3,     ThreadInfo[2].c_Time);

DDX_Control(pDX, IDC_THREAD4,   ThreadInfo[3].c_ThreadHandle);
DDX_Control(pDX, IDC_ID4,       ThreadInfo[3].c_ThreadID);
DDX_Control(pDX, IDC_GO4,       ThreadInfo[3].c_Go);
DDX_Control(pDX, IDC_PRI4,      ThreadInfo[3].c_Priority);
DDX_Control(pDX, IDC_AFF4_7,    ThreadInfo[3].c_Affinity[7]);
DDX_Control(pDX, IDC_AFF4_6,    ThreadInfo[3].c_Affinity[6]);
DDX_Control(pDX, IDC_AFF4_5,    ThreadInfo[3].c_Affinity[5]);
DDX_Control(pDX, IDC_AFF4_4,    ThreadInfo[3].c_Affinity[4]);
DDX_Control(pDX, IDC_AFF4_3,    ThreadInfo[3].c_Affinity[3]);
DDX_Control(pDX, IDC_AFF4_2,    ThreadInfo[3].c_Affinity[2]);
DDX_Control(pDX, IDC_AFF4_1,    ThreadInfo[3].c_Affinity[1]);
DDX_Control(pDX, IDC_AFF4_0,    ThreadInfo[3].c_Affinity[0]);
DDX_Control(pDX, IDC_MASK4,     ThreadInfo[3].c_Mask);
DDX_Control(pDX, IDC_PROGRESS4, ThreadInfo[3].c_Progress);
DDX_Control(pDX, IDC_TIME4,     ThreadInfo[3].c_Time);

DDX_Control(pDX, IDC_THREAD5,   ThreadInfo[4].c_ThreadHandle);
DDX_Control(pDX, IDC_ID5,       ThreadInfo[4].c_ThreadID);
DDX_Control(pDX, IDC_GO5,       ThreadInfo[4].c_Go);
DDX_Control(pDX, IDC_PRI5,      ThreadInfo[4].c_Priority);
DDX_Control(pDX, IDC_AFF5_7,    ThreadInfo[4].c_Affinity[7]);
DDX_Control(pDX, IDC_AFF5_6,    ThreadInfo[4].c_Affinity[6]);
DDX_Control(pDX, IDC_AFF5_5,    ThreadInfo[4].c_Affinity[5]);
DDX_Control(pDX, IDC_AFF5_4,    ThreadInfo[4].c_Affinity[4]);
DDX_Control(pDX, IDC_AFF5_3,    ThreadInfo[4].c_Affinity[3]);
DDX_Control(pDX, IDC_AFF5_2,    ThreadInfo[4].c_Affinity[2]);
DDX_Control(pDX, IDC_AFF5_1,    ThreadInfo[4].c_Affinity[1]);
DDX_Control(pDX, IDC_AFF5_0,    ThreadInfo[4].c_Affinity[0]);
DDX_Control(pDX, IDC_MASK5,     ThreadInfo[4].c_Mask);
DDX_Control(pDX, IDC_PROGRESS5, ThreadInfo[4].c_Progress);
DDX_Control(pDX, IDC_TIME5,     ThreadInfo[4].c_Time);

DDX_Control(pDX, IDC_THREAD6,   ThreadInfo[5].c_ThreadHandle);
DDX_Control(pDX, IDC_ID6,       ThreadInfo[5].c_ThreadID);
DDX_Control(pDX, IDC_GO6,       ThreadInfo[5].c_Go);
DDX_Control(pDX, IDC_PRI6,      ThreadInfo[5].c_Priority);
DDX_Control(pDX, IDC_AFF6_7,    ThreadInfo[5].c_Affinity[7]);
DDX_Control(pDX, IDC_AFF6_6,    ThreadInfo[5].c_Affinity[6]);
DDX_Control(pDX, IDC_AFF6_5,    ThreadInfo[5].c_Affinity[5]);
DDX_Control(pDX, IDC_AFF6_4,    ThreadInfo[5].c_Affinity[4]);
DDX_Control(pDX, IDC_AFF6_3,    ThreadInfo[5].c_Affinity[3]);
DDX_Control(pDX, IDC_AFF6_2,    ThreadInfo[5].c_Affinity[2]);
DDX_Control(pDX, IDC_AFF6_1,    ThreadInfo[5].c_Affinity[1]);
DDX_Control(pDX, IDC_AFF6_0,    ThreadInfo[5].c_Affinity[0]);
DDX_Control(pDX, IDC_MASK6,     ThreadInfo[5].c_Mask);
DDX_Control(pDX, IDC_PROGRESS6, ThreadInfo[5].c_Progress);
DDX_Control(pDX, IDC_TIME6,     ThreadInfo[5].c_Time);

DDX_Control(pDX, IDC_THREAD7,   ThreadInfo[6].c_ThreadHandle);
DDX_Control(pDX, IDC_ID7,       ThreadInfo[6].c_ThreadID);
DDX_Control(pDX, IDC_GO7,       ThreadInfo[6].c_Go);
DDX_Control(pDX, IDC_PRI7,      ThreadInfo[6].c_Priority);
DDX_Control(pDX, IDC_AFF7_7,    ThreadInfo[6].c_Affinity[7]);
DDX_Control(pDX, IDC_AFF7_6,    ThreadInfo[6].c_Affinity[6]);
DDX_Control(pDX, IDC_AFF7_5,    ThreadInfo[6].c_Affinity[5]);
DDX_Control(pDX, IDC_AFF7_4,    ThreadInfo[6].c_Affinity[4]);
DDX_Control(pDX, IDC_AFF7_3,    ThreadInfo[6].c_Affinity[3]);
DDX_Control(pDX, IDC_AFF7_2,    ThreadInfo[6].c_Affinity[2]);
DDX_Control(pDX, IDC_AFF7_1,    ThreadInfo[6].c_Affinity[1]);
DDX_Control(pDX, IDC_AFF7_0,    ThreadInfo[6].c_Affinity[0]);
DDX_Control(pDX, IDC_MASK7,     ThreadInfo[6].c_Mask);
DDX_Control(pDX, IDC_PROGRESS7, ThreadInfo[6].c_Progress);
DDX_Control(pDX, IDC_TIME7,     ThreadInfo[6].c_Time);

DDX_Control(pDX, IDC_THREAD8,   ThreadInfo[7].c_ThreadHandle);
DDX_Control(pDX, IDC_ID8,       ThreadInfo[7].c_ThreadID);
DDX_Control(pDX, IDC_GO8,       ThreadInfo[7].c_Go);
DDX_Control(pDX, IDC_PRI8,      ThreadInfo[7].c_Priority);
DDX_Control(pDX, IDC_AFF8_7,    ThreadInfo[7].c_Affinity[7]);
DDX_Control(pDX, IDC_AFF8_6,    ThreadInfo[7].c_Affinity[6]);
DDX_Control(pDX, IDC_AFF8_5,    ThreadInfo[7].c_Affinity[5]);
DDX_Control(pDX, IDC_AFF8_4,    ThreadInfo[7].c_Affinity[4]);
DDX_Control(pDX, IDC_AFF8_3,    ThreadInfo[7].c_Affinity[3]);
DDX_Control(pDX, IDC_AFF8_2,    ThreadInfo[7].c_Affinity[2]);
DDX_Control(pDX, IDC_AFF8_1,    ThreadInfo[7].c_Affinity[1]);
DDX_Control(pDX, IDC_AFF8_0,    ThreadInfo[7].c_Affinity[0]);
DDX_Control(pDX, IDC_MASK8,     ThreadInfo[7].c_Mask);
DDX_Control(pDX, IDC_PROGRESS8, ThreadInfo[7].c_Progress);
DDX_Control(pDX, IDC_TIME8,     ThreadInfo[7].c_Time);

DDX_Control(pDX, IDC_GUI,       ThreadInfo[MAX_THREADS].c_Priority);
DDX_Control(pDX, IDC_GUI_7,    ThreadInfo[MAX_THREADS].c_Affinity[7]);
DDX_Control(pDX, IDC_GUI_6,    ThreadInfo[MAX_THREADS].c_Affinity[6]);
DDX_Control(pDX, IDC_GUI_5,    ThreadInfo[MAX_THREADS].c_Affinity[5]);
DDX_Control(pDX, IDC_GUI_4,    ThreadInfo[MAX_THREADS].c_Affinity[4]);
DDX_Control(pDX, IDC_GUI_3,    ThreadInfo[MAX_THREADS].c_Affinity[3]);
DDX_Control(pDX, IDC_GUI_2,    ThreadInfo[MAX_THREADS].c_Affinity[2]);
DDX_Control(pDX, IDC_GUI_1,    ThreadInfo[MAX_THREADS].c_Affinity[1]);
DDX_Control(pDX, IDC_GUI_0,    ThreadInfo[MAX_THREADS].c_Affinity[0]);

DDX_Control(pDX, IDC_LOG, c_Log);
DDX_Control(pDX, IDC_ALL, c_All);
DDX_Control(pDX, IDC_PROCESS_PRIORITY, c_ProcessPriority);
DDX_Control(pDX, IDC_SHOWPRI1, c_PriorityDisplay[1]);
DDX_Control(pDX, IDC_SHOWPRI2, c_PriorityDisplay[2]);
DDX_Control(pDX, IDC_SHOWPRI3, c_PriorityDisplay[3]);
DDX_Control(pDX, IDC_SHOWPRI4, c_PriorityDisplay[4]);
DDX_Control(pDX, IDC_SHOWPRI5, c_PriorityDisplay[5]);
DDX_Control(pDX, IDC_SHOWPRI6, c_PriorityDisplay[6]);
DDX_Control(pDX, IDC_SHOWPRI7, c_PriorityDisplay[7]);
DDX_Control(pDX, IDC_SHOWPRI8, c_PriorityDisplay[8]);
DDX_Control(pDX, IDC_SHOWPRI9, c_PriorityDisplay[9]);
DDX_Control(pDX, IDC_SHOWPRI10, c_PriorityDisplay[10]);
DDX_Control(pDX, IDC_SHOWPRI11, c_PriorityDisplay[11]);
DDX_Control(pDX, IDC_SHOWPRI12, c_PriorityDisplay[12]);
DDX_Control(pDX, IDC_SHOWPRI13, c_PriorityDisplay[13]);
DDX_Control(pDX, IDC_SHOWPRI14, c_PriorityDisplay[14]);
DDX_Control(pDX, IDC_SHOWPRI15, c_PriorityDisplay[15]);
DDX_Control(pDX, IDC_GRAPH, c_Graph0);
DDX_Control(pDX, IDC_COPY, c_Copy);
DDX_Control(pDX, IDC_TEST_LENGTH, c_TestLength);
DDX_Control(pDX, IDC_COPYALL, c_CopyAll);
DDX_Control(pDX, IDC_STOP, c_Stop);
DDX_Control(pDX, IDC_FRAME, c_Frame);
DDX_Control(pDX, IDC_RESET_ALL, c_ResetAll);
DDX_Control(pDX, IDC_CONFIGURATION, c_Configurations);
DDX_Control(pDX, IDC_COPYRECT, c_CopyRect);
DDX_Control(pDX, IDC_LAUNCH, c_Launch);
DDX_Control(pDX, IDC_COPY_PRIORITY_CLASS, c_CopyPriorityClass);
DDX_Control(pDX, IDC_PRIORITY_CLASS_FRAME, c_PriorityCopyFrame);
DDX_Control(pDX, IDC_COPY_PROGRESS_FRAME, c_CopyProgressFrame);
DDX_Control(pDX, IDC_COPY_PROGRESS, c_CopyProgress);
}

/****************************************************************************
*                                 Message Map
****************************************************************************/

BEGIN_MESSAGE_MAP(CaffinityDlg, CDialog)
        ON_BN_CLICKED(IDC_ALL, OnBnClickedAll)
        ON_BN_CLICKED(IDC_COPY, OnBnClickedCopy)
        ON_BN_CLICKED(IDC_COPYALL, OnBnClickedCopyall)
        ON_BN_CLICKED(IDC_GO1, OnBnClickedGo1)
        ON_BN_CLICKED(IDC_GO2, OnBnClickedGo2)
        ON_BN_CLICKED(IDC_GO3, OnBnClickedGo3)
        ON_BN_CLICKED(IDC_GO4, OnBnClickedGo4)
        ON_BN_CLICKED(IDC_GO5, OnBnClickedGo5)
        ON_BN_CLICKED(IDC_GO6, OnBnClickedGo6)
        ON_BN_CLICKED(IDC_GO7, OnBnClickedGo7)
        ON_BN_CLICKED(IDC_GO8, OnBnClickedGo8)
        ON_BN_CLICKED(IDC_LAUNCH, OnBnClickedLaunch)
        ON_BN_CLICKED(IDC_RESET_ALL, OnBnClickedResetAll)
        ON_BN_CLICKED(IDC_STOP, OnBnClickedStop)
        ON_CBN_SELENDOK(IDC_CONFIGURATION, OnCbnSelendokConfiguration)
        ON_CBN_SELENDOK(IDC_GUI, OnCbnSelendokGUI)
        ON_CBN_SELENDOK(IDC_PRI1, OnCbnSelendokPri1)
        ON_CBN_SELENDOK(IDC_PRI2, OnCbnSelendokPri2)
        ON_CBN_SELENDOK(IDC_PRI3, OnCbnSelendokPri3)
        ON_CBN_SELENDOK(IDC_PRI4, OnCbnSelendokPri4)
        ON_CBN_SELENDOK(IDC_PRI5, OnCbnSelendokPri5)
        ON_CBN_SELENDOK(IDC_PRI6, OnCbnSelendokPri6)
        ON_CBN_SELENDOK(IDC_PRI7, OnCbnSelendokPri7)
        ON_CBN_SELENDOK(IDC_PRI8, OnCbnSelendokPri8)
        ON_CBN_SELENDOK(IDC_PROCESS_PRIORITY, OnCbnSelendokProcessPriority)
        ON_CBN_SELENDOK(IDC_TEST_LENGTH, OnCbnSelendokTestLength)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFF1_0, IDC_AFF1_7, OnAff1)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFF2_0, IDC_AFF2_7, OnAff2)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFF3_0, IDC_AFF3_7, OnAff3)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFF4_0, IDC_AFF4_7, OnAff4)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFF5_0, IDC_AFF5_7, OnAff5)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFF6_0, IDC_AFF6_7, OnAff6)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFF7_0, IDC_AFF7_7, OnAff7)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_AFF8_0, IDC_AFF8_7, OnAff8)
        ON_CONTROL_RANGE(BN_CLICKED, IDC_GUI_0,  IDC_GUI_7,  OnGUI)
        ON_NOTIFY_EX(TTN_NEEDTEXT, 0, OnToolTipNotify)
        ON_REGISTERED_MESSAGE(UWM_ANY_RUNNING, OnAnyRunning)
        ON_REGISTERED_MESSAGE(UWM_CLICK_ALL, OnClickAll)
        ON_REGISTERED_MESSAGE(UWM_CONFIGURATION_CHANGE, OnConfigurationChange)
        ON_REGISTERED_MESSAGE(UWM_LOG, OnLog)
        ON_REGISTERED_MESSAGE(UWM_PROCESS_NOTIFICATION, OnProcessNotification)
        ON_REGISTERED_MESSAGE(UWM_REQUEST_PLOT, OnRequestPlot)
        ON_REGISTERED_MESSAGE(UWM_RUN_ALL, OnRunAll)
        ON_REGISTERED_MESSAGE(UWM_SETPOS, OnSetPos)
        ON_REGISTERED_MESSAGE(UWM_SETUP_COMPLETE, OnSetupComplete)
        ON_REGISTERED_MESSAGE(UWM_STARTUP_FAILURE, OnStartupFailure)
        ON_REGISTERED_MESSAGE(UWM_THREAD_STOPPED, OnStopped)
        ON_WM_CLOSE()
        ON_WM_COPYDATA()
        ON_WM_DESTROY()
        ON_WM_GETMINMAXINFO()
        ON_WM_LBUTTONDOWN()
        ON_WM_LBUTTONUP()
        ON_WM_MOUSEMOVE()
        ON_WM_PAINT()
        ON_WM_QUERYDRAGICON()
        ON_WM_SETCURSOR()
        ON_WM_SIZE()
        ON_WM_SYSCOMMAND()
        ON_COMMAND(ID_HELP_ABOUT, OnHelpAbout)
        ON_COMMAND(ID_FILE_EXIT, OnFileExit)
        ON_COMMAND(ID_LOG_SAVE, OnLogSave)
        ON_COMMAND(ID_LOG_SAVEAS, OnLogSaveas)
        ON_COMMAND(ID_LOG_PRINT, OnLogPrint)
        ON_COMMAND(ID_LOG_CLEAR, OnLogClear)
        ON_WM_INITMENUPOPUP()
        ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
        ON_COMMAND(ID_EDIT_CUT, OnEditCut)
        ON_COMMAND(ID_EDIT_DELETE, OnEditDelete)
        ON_COMMAND(ID_EDIT_SELECTALL, OnEditSelectall)
        ON_COMMAND(ID_LOG_TOTOP, OnLogToTop)
        ON_COMMAND(ID_LOG_TONEXTERROR, OnLogToNextError)
        ON_COMMAND(ID_LOG_TOPREVIOUSERROR, OnLogToPreviousError)
        ON_COMMAND(ID_LOG_TOEND, OnLogToEnd)
        ON_COMMAND(ID_LOG_SETFONT, OnLogSetfont)
        ON_BN_CLICKED(IDC_COPY_PRIORITY_CLASS, OnBnClickedCopyPriorityClass)
        ON_BN_CLICKED(IDC_COPY_PROGRESS, OnBnClickedCopyProgress)
END_MESSAGE_MAP()

/****************************************************************************
*                     CaffinityDlg::InitSecondaryInstance
* Result: void
*       
* Effect: 
*       Initializes controls for a secondary instance
****************************************************************************/

void CaffinityDlg::InitSecondaryInstance()
    {
     Primary = FALSE;
     
     //****************************************************************
     // Disable the launch option and hide it
     //****************************************************************
     c_Launch.EnableWindow(FALSE);
     c_Launch.ShowWindow(SW_HIDE);

     //****************************************************************
     // Secondary instances do not have graphs
     //****************************************************************
     // Hide the graph window and its copy button
     c_Graph0.ShowWindow(SW_HIDE);
     c_Copy.ShowWindow(SW_HIDE);

     // Extend the log window to be the full width of the client area
     CRect c;
     GetClientRect(&c);
     CRect r;
     c_Log.GetWindowRect(&r);
     ScreenToClient(&r);
     c_Log.SetWindowPos(NULL,
                        0,0,
                        c.Width(), r.Height(),
                        SWP_NOMOVE | SWP_NOZORDER);
    } // CaffinityDlg::InitSecondaryInstance

/****************************************************************************
*                     CaffinityDlg::ParseCommandParameter
* Inputs:
*       const CString & key: Keyword to search for
*       const CString & prefix: Prefix, "/" or "-"
*       CString & result: Place to put result
* Result: BOOL
*       TRUE if found
*       FALSE if not found
****************************************************************************/

BOOL CaffinityDlg::ParseCommandParameter(const CString& key, const CString & prefix, CString & result)
    {
     //----------------------------------
     // DesiredOption: "-name" or "/name"
     //----------------------------------
     CString DesiredOption = prefix + key;   // "-name" or "/name"

     //----------------------------------
     // DesiredOption: "-NAME" or "/NAME"
     //----------------------------------
     DesiredOption = DesiredOption.MakeUpper();

     for(int i = 1; i < __argc; i++)
        { /* compare */
         //------------------------
         //   argv: "/option:value"
         //------------------------
         CString argv;
         argv = __targv[i];

         //------------------------
         //  test: "/option"
         //------------------------
         CString test;
         test = argv.Left(test.GetLength());

         //------------------------
         // test: "/OPTION"
         //------------------------
         test = test.MakeUpper();
         
         if(test == DesiredOption)
            { /* got it */
             if(test.GetLength() == argv.GetLength())
                { /* present, no value */
                 result = _T("");
                 return TRUE;
                } /* present, no value */

             //------------------------------
             // parameter: ":value"
             //------------------------------
             CString parameter = argv.Mid(test.GetLength());

             if(parameter.GetLength() == 0)
                { /* no arg */
                 result = _T("");
                 return TRUE;
                } /* no arg */
             if(parameter[0] != _T(':'))
                { /* bad syntax */
                 return FALSE;
                } /* bad syntax */
             //------------------------
             // parameter: "name"
             //------------------------
             parameter = parameter.Mid(1);

             result = parameter;
             return TRUE;
            } /* got it */

         // We didn't have a match, let the loop continue and try the next one
        } /* compare */
     return FALSE; // not found
    } // CaffinityDlg::ParseCommandParameter

/****************************************************************************
*                      CaffinityDlg::GetCommandParameter
* Inputs:
*       const CString & key: Command line key
* Result: CString
*       The parameter associated with the key.  Empty if the key is
*       not found
****************************************************************************/

CString CaffinityDlg::GetCommandParameter(const CString & key)
    {
     CString result;
     if(ParseCommandParameter(key, _T("/"), result))
        return result;
     ParseCommandParameter(key, _T("-"), result);
     return result;
    } // CaffinityDlg::GetCommandParameter

/****************************************************************************
*                     CaffinityDlg::SelectRegistryConfig
* Result: void
*       
* Effect: 
*       Selects the configuration to be the one in the Registry, or
*       none at all if it can't be found
****************************************************************************/

void CaffinityDlg::SelectRegistryConfig()
    {
     RegistryString curcfg(IDS_REGISTRY_CURRENT_CONFIGURATION);
     curcfg.load();
     if(!curcfg.value.IsEmpty())
        { /* has value */
         int n = c_Configurations.FindStringExact(-1, curcfg.value);
         if(n != CB_ERR)
            { /* has config */
             Log(new TraceFormatComment(TraceEvent::None, IDS_SELECTING_CONFIG, curcfg.value));
             c_Configurations.SetCurSel(n);
            } /* has config */
         else
            { /* error */
             // for now...
             Log(new TraceFormatError(TraceEvent::None, IDS_CONFIG_NOT_FOUND, curcfg.value));
             c_Configurations.SetCurSel(CB_ERR);
            } /* error */
        } /* has value */
     else
        { /* no configuration set */
         Log(new TraceComment(TraceEvent::None, IDS_USING_DEFAULT_CONFIG));
         c_Configurations.SetCurSel(CB_ERR);
        } /* no configuration set */
    } // CaffinityDlg::SelectRegistryConfig

/****************************************************************************
*                      CaffinityDlg::SelectConfiguration
* Result: void
*       
* Effect: 
*       Selects the desired configuration
****************************************************************************/

void CaffinityDlg::SelectConfiguration()
    {
     //********************************************
     // Configuration: Load existing configurations
     //********************************************
     // Then figure out which is the current config and select that one
     // The rules here are
     //      1. If there is a command line request, use its configuration name
     //         a. If that configuration name does not exist, try the base name
     //         b. If the base name does not exist, use the default
     //      2. If there is no command line request, use the registry name
     //         a. If there is no registry name, use the (default) configuration
     //
     // The command line contains two relevant options here:
     //      /config:name  /seq:n
     // If seq is not specified, the attempt is to use the name specified
     // by /config:name.  This is the "base name"
     // If /seq is specified with /config, then the name used is
     //      name-n
     // If /seq is specified but /config is not, then the
     // Registry key -n is used
     //
     CString config = GetCommandParameter(_T("config"));
     CString seq = GetCommandParameter(_T("seq"));

     //****************************************************************
     // Try the config-seq mechanism
     //****************************************************************
     if(!config.IsEmpty() && !seq.IsEmpty())
        { /* config-seq */
         CString configName = config + _T("-") + seq;
         int n = c_Configurations.FindStringExact(-1, configName);
         if(n != CB_ERR)
            { /* found config-seq */
             Log(new TraceFormatComment(TraceEvent::None, IDS_SELECTING_CONFIG, configName));
             c_Configurations.SetCurSel(n);
             return;
            } /* found config-seq */

         Log(new TraceFormatError(TraceEvent::None, IDS_CONFIG_NOT_FOUND, configName));
         
         // config-seq wasn't find, try just config
         n = c_Configurations.FindStringExact(-1, config);
         if(n != CB_ERR)
            { /* found config */
             Log(new TraceFormatComment(TraceEvent::None, IDS_SELECTING_CONFIG, config));
             c_Configurations.SetCurSel(n);
             return;
            } /* found config */

         // The config-seq wasn't found, nor was config.  Assume these are bogus
         // and use the default
         SelectRegistryConfig();
         return;
        } /* config-seq */

     //****************************************************************
     // Try the seq-only approach, using the Registry config
     //****************************************************************

     if(config.IsEmpty() && !seq.IsEmpty())
        { /* registry-seq */
         RegistryString curcfg(IDS_REGISTRY_CURRENT_CONFIGURATION);
         curcfg.load();

         CString configName = curcfg.value + _T("-") + seq;
         int n = c_Configurations.FindStringExact(-1, configName);
         if(n != CB_ERR)
            { /* found it */
             Log(new TraceFormatComment(TraceEvent::None, IDS_SELECTING_CONFIG, configName));
             c_Configurations.SetCurSel(n);
             return;
            } /* found it */

         // We could not find registry-seq
         SelectRegistryConfig();
         return;
        } /* registry-seq */
     
     if(!config.IsEmpty() && seq.IsEmpty())
        { /* config */
         int n = c_Configurations.FindStringExact(-1, config);
         if(n != CB_ERR)
            { /* found config */
             Log(new TraceFormatComment(TraceEvent::None, IDS_SELECTING_CONFIG, config));
             c_Configurations.SetCurSel(n);
             return;
            } /* found config */
         SelectRegistryConfig();
         return;
        } /* config */

     // config.IsEmpty() && seq.IsEmpty()
     SelectRegistryConfig();
    } // CaffinityDlg::SelectConfiguration

/****************************************************************************
*                         CaffinityDlg::OnInitDialog
* Result: BOOL
*       TRUE, always
* Effect: 
*       Initializes the controls
****************************************************************************/

BOOL CaffinityDlg::OnInitDialog()
{
        CDialog::OnInitDialog();

        // Add "About..." menu item to system menu.

        // IDM_ABOUTBOX must be in the system command range.
        ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
        ASSERT(IDM_ABOUTBOX < 0xF000);

        CMenu* pSysMenu = GetSystemMenu(FALSE);
        if (pSysMenu != NULL)
        {
                CString strAboutMenu;
                strAboutMenu.LoadString(IDS_ABOUTBOX);
                if (!strAboutMenu.IsEmpty())
                {
                        pSysMenu->AppendMenu(MF_SEPARATOR);
                        pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
                }
        }

        // Set the icon for this dialog.  The framework does this automatically
        //  when the application's main window is not a dialog
        SetIcon(m_hIcon, TRUE);                 // Set big icon
        SetIcon(m_hIcon, FALSE);                // Set small icon

        //****************************************************************
        // AffinityDlg initialization
        //****************************************************************

        // If this is the first instance, it becomes, by definition, the "master copy" and
        // all plotting is done in it.  It will also broadcast out the "Run All" event

        if(MasterController == STARTUP_FAILURE_HWND)
           { /* cannot continue to run */
            // This is a secondary version and it is unable to proceed
            PostMessage(UWM_STARTUP_FAILURE);
           } /* cannot continue to run */
        else
           { /* MasterController undefined or valid */
            CreationMutex = ::CreateMutex(NULL, FALSE, _T("CreationMutex-{595BA37C-B700-4835-8854-9EED5A6A0896}"));
            if(CreationMutex == NULL)
               { /* failure during creation */
                DWORD err = ::GetLastError();
                Log(new TraceError(TraceEvent::None, IDS_MUTEX_CREATION_FAILURE));
                Log(new TraceFormatMessage(TraceEvent::None, err));
                MasterController = STARTUP_FAILURE_HWND;
               } /* failure during creation */
            else
               { /* check if first instance */
                if(::GetLastError() == ERROR_SUCCESS)
                   { /* first instance */
                    Log(new TraceFormatComment(TraceEvent::None, IDS_MASTER_CONTROLLER_STARTED, m_hWnd));
                    MasterController = m_hWnd;  // we are the master! (Blue drinks optional)
                   } /* first instance */
                else
                   { /* secondary instance */
                    Log(new TraceFormatComment(TraceEvent::None, IDS_SECONDARY_CONTROLLER_STARTED, MasterController));
                    InitSecondaryInstance();
                   } /* secondary instance */

                // Primary or secondary, notify that we have a new process
                Log(new TraceFormatComment(TraceEvent::None, IDS_UWM_PROCESS_NOTIFICATION_SENT, _T("true"), m_hWnd));
                ::PostMessage(MasterController, UWM_PROCESS_NOTIFICATION, (WPARAM)TRUE, (LPARAM)m_hWnd);
               } /* check if first instance */
           } /* MasterController undefined or valid */
        
        GetProcessAffinityMask(::GetCurrentProcess(), &processAffinityMask, &systemAffinityMask);
        Log(new TraceFormatComment(TraceEvent::None, IDS_SYSTEM_AFFINITY_MASK, systemAffinityMask));
        
        //***************************************
        // Initialize the per-thread control data
        //***************************************

        // Set the index value so we can figure out which thread we are
        for(int i = 0; i < MAX_THREADS; i++)
           ThreadInfo[i].SetIndex(i);

        // The last element is the main GUI thread; initialize it to TraceEvent::None
        // (this is based on the fact that we use the thread index as the first
        // parameter to creating TraceEvent-derived classes)
        ThreadInfo[MAX_THREADS].SetIndex(TraceEvent::None);

        // Enable the affinity masks for all (including the GUI thread) threads
        for(int i = 0; i < MAX_THREADS + 1; i++) // this includes the GUI mask!
           ThreadInfo[i].EnableByMask(systemAffinityMask);

        // Initialize all the other controls for the thread
        for(int i = 0; i < MAX_THREADS + 1; i++)
           ThreadInfo[i].InitControls(this);

        //******************
        // Graph information
        //******************

        CRect G;
        c_Graph0.GetWindowRect(&G);
        ScreenToClient(&G);
        c_Graph0.ShowWindow(SW_HIDE);

        // Position the copy button over the graph area
        c_CopyRect.MoveWindow(&G);

        //*****************
        // Process priority
        //*****************
        c_ProcessPriority.Initialize();
        c_ProcessPriority.Select(NORMAL_PRIORITY_CLASS);

        //****************
        // Test length
        //****************
        c_TestLength.AddStrings(IterationTable);
        c_TestLength.Select(DEFAULT_ITERATIONS);

        //******************
        // GUI affinity mask
        //******************
        ThreadInfo[MAX_THREADS].SetAffinityMask(systemAffinityMask); // GUI runs everywhere

        //***************************
        // Set bitmap on copy buttons
        //***************************
        CBitmap bmp;
        bmp.LoadBitmap(IDB_COPY);
        c_Copy.SetBitmap((HBITMAP)bmp);
        c_CopyAll.SetBitmap((HBITMAP)bmp);
        c_CopyPriorityClass.SetBitmap((HBITMAP)bmp);
        c_CopyProgress.SetBitmap((HBITMAP)bmp);
        bmp.Detach();
        
        //*************************************
        // Configuration: Create <New...> entry
        //*************************************
        CString newcfg;
        newcfg.LoadString(IDS_NEW_CONFIG);
        int newcfgIndex = c_Configurations.AddString(newcfg);
        c_Configurations.SetItemData(newcfgIndex, CONFIGURATION_NEW);

        //********************************************
        // Configuration: Load existing configurations
        //********************************************
        // First, enumerate all the configuration keys
        CStringArray configs;
        EnumRegistryKeys(HKEY_CURRENT_USER, IDS_REGISTRY_CONFIGURATIONS, configs);

        for(int i = 0; i < configs.GetSize(); i++)
           { /* add to combo */
            c_Configurations.AddString(configs[i]);
           } /* add to combo */

        SelectConfiguration();

        StopWatchEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL);
        if(StopWatchEvent == NULL)
           { /* error */
            DWORD err = ::GetLastError();
            Log(new TraceError(TraceEvent::None, IDS_STOPWATCH_EVENT_FAILED));
            Log(new TraceFormatMessage(TraceEvent::None, err));
           } /* error */
        else
           { /* successful */
            AfxBeginThread(WatchConfigurationKey, this);
           } /* successful */

        LoadProfile();
        
        EnableToolTips();

        updateControls();

        //****************************************************************
        // Now, the dialog has become centered on the screen.  But
        // we want child dialogs to be offset from each other.  So
        // we have to compensate for the defect that forces a dialog-based
        // app to *always* start centered on the screen and ignore its
        // startup parameters
        //****************************************************************

        STARTUPINFO startup;
        ::GetStartupInfo(&startup);
        if(startup.dwFlags & STARTF_USEPOSITION)
           { /* a position had been set */
           Log(new TraceFormatComment(TraceEvent::None, IDS_TRACE_STARTUP_POS, startup.dwX, startup.dwY));
            SetWindowPos(NULL,
                         startup.dwX,
                         startup.dwY,
                         0,0,
                         SWP_NOSIZE | SWP_NOZORDER);
           } /* a position had been set */
        

        return TRUE;  // return TRUE  unless you set the focus to a control
}

/****************************************************************************
*                         CaffinityDlg::OnSysCommand
* Inputs:
*       UINT nID: command ID (mask of low-order 4 bits)
*       LPARAM lParam:
* Result: void
*       
* Effect: 
*       Handles the system menu
****************************************************************************/

void CaffinityDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
        if ((nID & 0xFFF0) == IDM_ABOUTBOX)
        {
                CAboutDlg dlgAbout;
                dlgAbout.DoModal();
        }
        else
        {
                CDialog::OnSysCommand(nID, lParam);
        }
}

/****************************************************************************
*                            CaffinityDlg::OnPaint
* Result: void
*       
* Effect: 
*       Draws the icon for the dialog
* Notes:
* If you add a minimize button to your dialog, you will need the code below
*  to draw the icon.  For MFC applications using the document/view model,
*  this is automatically done for you by the framework.
****************************************************************************/

void CaffinityDlg::OnPaint() 
{
        if (IsIconic())
        {
                CPaintDC dc(this); // device context for painting

                SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

                // Center icon in client rectangle
                int cxIcon = GetSystemMetrics(SM_CXICON);
                int cyIcon = GetSystemMetrics(SM_CYICON);
                CRect rect;
                GetClientRect(&rect);
                int x = (rect.Width() - cxIcon + 1) / 2;
                int y = (rect.Height() - cyIcon + 1) / 2;

                // Draw the icon
                dc.DrawIcon(x, y, m_hIcon);
        }
        else
        {
                CDialog::OnPaint();
        }
}

/****************************************************************************
*                        CaffinityDlg::OnQueryDragIcon
* Result: HCURSOR
*       A drag cursor
* Notes:
*       The system calls this function to obtain the cursor to display while
*       the user drags the minimized window.
****************************************************************************/

HCURSOR CaffinityDlg::OnQueryDragIcon()
{
        return static_cast<HCURSOR>(m_hIcon);
}

/****************************************************************************
*                             CaffinityDlg::OnOK
* Result: void
*       
* Effect: 
*       Does nothing; keeps <enter> from closing dialog
****************************************************************************/

void CaffinityDlg::OnOK()
    {

    }

/****************************************************************************
*                           CaffinityDlg::OnCancel
* Result: void
*       
* Effect: 
*       Does nothing; keeps <esc> from closing dialog
****************************************************************************/

void CaffinityDlg::OnCancel()
    {

    }

/****************************************************************************
*                            CaffinityDlg::OnClose
* Result: void
*       
* Effect: 
*       If there are child processes, closes them and delays shutdown
*       until all processes have been killed.
****************************************************************************/

void CaffinityDlg::OnClose()
    {
     if(!Primary || children.GetSize() <= 1)
        CDialog::OnOK();

     // Otherwise, notify the child processes and shut down only when they have
     // finished
     Log(new TraceFormatComment(TraceEvent::None, IDS_DEFERRING_SHUTDOWN, children.GetSize()));
     closing = TRUE;
     children.PostMessage(WM_CLOSE);
    }

/****************************************************************************
*                CaffinityDlg::CThreadControl::SetAffinityMask
* Inputs:
*       UINT_PTR m: Desired mask
* Result: void
*       
* Effect: 
*       Sets the affinity mask to the controls
****************************************************************************/

void CaffinityDlg::CThreadControl::SetAffinityMask(UINT_PTR m)
    {
     for(int i = 0; i < MAX_CPUS; i++)
        { /* mask loop */
         c_Affinity[i].SetCheck(( (m>>i) & 1) ? BST_CHECKED : BST_UNCHECKED);
        } /* mask loop */
    } // CaffinityDlg::ThreadControl::SetAffinityMask

/****************************************************************************
*                CaffinityDlg::ThreadControl::GetAffinityMask
* Result: DWORD_PTR
*       The mask as derived from the controls
****************************************************************************/

DWORD_PTR CaffinityDlg::CThreadControl::GetAffinityMask()
    {
     DWORD_PTR m = 0;
     for(int i = 0; i < MAX_CPUS; i++)
        { /* GetCheck */
         if(c_Affinity[i].GetCheck() == BST_CHECKED)
            m |= (DWORD_PTR)1 << i;
        } /* GetCheck */
     return m;
    } // CaffinityDlg::CThreadControl::GetAffinityMask

/****************************************************************************
*                  CaffinityDlg::CThreadControl::EnableByMask
* Inputs:
*       UINT_PTR m: System mask
* Result: void
*       
* Effect: 
*       Enables/disables controls based on mask
****************************************************************************/

void CaffinityDlg::CThreadControl::EnableByMask(UINT_PTR m)
    {
     for(int i = 0; i < MAX_CPUS; i++)
        { /* disable controls */
         c_Affinity[i].EnableWindow( (bool)((m >> i) & 1));
        } /* disable controls */
    } // CaffinityDlg::CThreadControl::EnableByMask

/****************************************************************************
*                 CaffinityDlg::CThreadControl::InitControls
* Result: void
*       
* Effect: 
*       Initializes the controls
****************************************************************************/

void CaffinityDlg::CThreadControl::InitControls(CWnd * wnd)
    {
     parent = wnd;
     if(c_ThreadHandle.GetSafeHwnd() != NULL)
        c_ThreadHandle.SetWindowText(_T(""));
     if(c_ThreadID.GetSafeHwnd() != NULL)
        c_ThreadID.SetWindowText(_T(""));
     c_Priority.Initialize();
     
     ResetControls();
    } // CaffinityDlg::CThreadControl::InitControls

/****************************************************************************
*                 CaffinityDlg::CThreadControl::ResetControls
* Result: void
*       
* Effect: 
*       Sets the controls to an initial state
****************************************************************************/

void CaffinityDlg::CThreadControl::ResetControls()
    {
     //****************************************************************
     // Set the default thread priority selection
     //****************************************************************
     c_Priority.Select(THREAD_PRIORITY_NORMAL);

     for(int i = 0; i < MAX_CPUS; i++)
        c_Affinity[i].SetCheck(BST_UNCHECKED);

     //****************************************************************
     // Reset the time value if it exists (the GUI doesn't have one)
     //****************************************************************
     if(c_Time.GetSafeHwnd() != NULL)
        c_Time.SetWindowText(_T(""));

     //****************************************************************
     // Reset the progress bar (if one exists: the GUI doesn't have one)
     //****************************************************************
     if(c_Progress.GetSafeHwnd() != NULL)
        { /* init progress */
         c_Progress.SetRange(0, 99);
         c_Progress.SetPos(0);
        } /* init progress */
    } // CaffinityDlg::CThreadControl::ResetControls

/****************************************************************************
*                CaffinityDlg::CThreadControl::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CaffinityDlg::CThreadControl::updateControls()
    {
     BOOL EnableGo = TRUE;
     EnableGo = CanGo();
     
     // Note that SendMessage works because this code is ALWAYS
     // executed in the main GUI thread
     EnableGo &= !(BOOL)parent->SendMessage(UWM_ANY_RUNNING);
     c_Go.EnableWindow(EnableGo);

     CString s;
     s.Format(_T("%02x"), GetAffinityMask());
     CString old;
     c_Mask.GetWindowText(old);
     if(old != s)
        c_Mask.SetWindowText(s);

     // Note: For now, we do not allow changing priorities in the middle of
     // a run, although the code is there to handle it.  This is solely
     // because of the complexity of handling color changes in the plot line
     // which is more than I want to try right now
     EnablePriority(!HasThread());

    } // CaffinityDlg::CThreadControl::updateControls

/****************************************************************************
*                CaffinityDlg::CThreadControl::CThreadControl
* Effect: 
*       Constructor
****************************************************************************/

CaffinityDlg::CThreadControl::CThreadControl()
    {
     running = FALSE;
     thread = NULL;
     parent = NULL;
     iterations = DEFAULT_ITERATIONS;
    } // CaffinityDlg::CThreadControl::CThreadControl

/****************************************************************************
*                      CaffinityDlg::CThreadControl::runthread
* Inputs:
*       LPVOID p: (LPVOID)(CaffinityDlg::CThreadControl *)
* Result: UINT
*       Logically void, 0, always
* Effect: 
*       Transfers control to the actual thread
****************************************************************************/

/* static */ UINT CaffinityDlg::CThreadControl::runthread(LPVOID p)
    {
     CaffinityDlg::CThreadControl * self = (CaffinityDlg::CThreadControl *)p;
     self->runthread();
     return 0;
    } // CaffinityDlg::CThreadControl::runthread

/****************************************************************************
*                    CaffinityDlg::CThreadControl::runthread
* Result: void
*       
* Effect: 
*       Runs the thread
****************************************************************************/

void CaffinityDlg::CThreadControl::runthread()
    {
     for(int i = 0; i < 100; i++)
        { /* loop */
         if(!running)
            break;
         for(int k = 0; k < iterations * ITERATION_MULTIPLIER; k++)
            { /* loop */
             if(!running)
                break;
             DoNothing();
            } /* loop */

         POSINFO * posinfo = new POSINFO;

         // Initialize all the fields except the graph pointer (which is set by the receiver)
         posinfo->wnd = AfxGetApp()->m_pMainWnd->m_hWnd;
         posinfo->index = index;
         posinfo->time = ::GetTickCount() - start;
         posinfo->pos = i;
         posinfo->priority = priority;

         parent->PostMessage(UWM_SETPOS, (WPARAM)this, (LPARAM)posinfo);
        } /* loop */
     running = FALSE;
     DWORD end = ::GetTickCount();
     parent->PostMessage(UWM_THREAD_STOPPED, (WPARAM)this, (LPARAM)(end - start));
    } // CaffinityDlg::CThreadControl::runthread

/****************************************************************************
*                   CaffinityDlg::CThreadControl::DoNothing
* Result: void
*       
* Effect: 
*       Does nothing
****************************************************************************/

void CaffinityDlg::CThreadControl::DoNothing()
    {
     // empty body
    } // CaffinityDlg::CThreadControl::DoNothing

/****************************************************************************
*                 CaffinityDlg::CThreadControl::SetProgress
* Inputs:
*       int n: value to set
* Result: void
*       
* Effect: 
*       Sets the progress bar
****************************************************************************/

void CaffinityDlg::CThreadControl::SetProgress(int n)
    {
     c_Progress.SetPos(n);
    } // CaffinityDlg::CThreadControl::SetProgress

/****************************************************************************
*                 CaffinityDlg::CThreadControl::ResetProgress
* Result: void
*       
* Effect: 
*       Resets the progress bar
****************************************************************************/

void CaffinityDlg::CThreadControl::ResetProgress()
    {
     c_Progress.SetPos(0);
    } // CaffinityDlg::CThreadControl::ResetProgress


/****************************************************************************
*                           CaffinityDlg::OnSetPos
* Inputs:
*       WPARAM: (WPARAM)(ThreadControl *)
*       LPARAM: (LPARAM)(POSINFO *)
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Sets the progress control
****************************************************************************/

LRESULT CaffinityDlg::OnSetPos(WPARAM wParam, LPARAM lParam)
    {
     CThreadControl * tc = (CThreadControl *)wParam;
     POSINFO * posinfo = (POSINFO *)lParam;

     // Set the local progress bar
     tc->SetProgress(posinfo->pos);

     COPYDATASTRUCT cds = {0};
     cds.lpData = posinfo;
     cds.cbData = sizeof(POSINFO);
     cds.dwData = CopyDataTypes::GraphPoint;
     posinfo->guid = CopyGUID;


     ::SendMessage(MasterController, WM_COPYDATA, (WPARAM)m_hWnd, (LPARAM)&cds);

     delete posinfo;
     return 0;
    } // CaffinityDlg::OnSetPos

/****************************************************************************
*                        CaffinityDlg::updateControls
* Result: void
*       
* Effect: 
*       Updates the controls
****************************************************************************/

void CaffinityDlg::updateControls()
    {
     for(int i = 0; i < MAX_THREADS; i++)
        ThreadInfo[i].updateControls();

     BOOL anyRunning = (BOOL)SendMessage(UWM_ANY_RUNNING); 

     //****************
     // All
     //****************
     BOOL EnableAll = FALSE;
     for(int i = 0; i < MAX_THREADS; i++)
        { /* enable it */
         EnableAll |= ThreadInfo[i].CanGo();
        } /* enable it */
     if(EnableAll)
        EnableAll &= !anyRunning;

     c_All.EnableWindow(EnableAll);

     //****************
     // Test Length
     // ProcessPriority
     // Copy
     // Stop
     // Reset All
     //****************
     c_TestLength.EnableWindow(!anyRunning);
     c_ProcessPriority.EnableWindow(!anyRunning);
     c_Copy.EnableWindow(!anyRunning);
     c_Stop.EnableWindow(anyRunning);
     c_ResetAll.EnableWindow(!anyRunning);

     //****************
     // Priority selection
     //****************

     for(int i = 1; i < 16; i++)
        { /* set each */
         int priority = c_ProcessPriority.GetCurThreadPriority(i);
         c_PriorityDisplay[i].SetPriority(priority);
         switch(priority)
            { /* priority */
             case UNAVAILABLE:
                c_PriorityDisplay[i].EnableWindow(FALSE);
                break;
             case THREAD_PRIORITY_IDLE:
             case THREAD_PRIORITY_LOWEST:
             case THREAD_PRIORITY_BELOW_NORMAL:
             case THREAD_PRIORITY_NORMAL:
             case THREAD_PRIORITY_ABOVE_NORMAL:
             case THREAD_PRIORITY_HIGHEST:
             case THREAD_PRIORITY_TIME_CRITICAL:
                c_PriorityDisplay[i].EnableWindow(TRUE);
                break;
            } /* priority */
        } /* set each */
    } // CaffinityDlg::updateControls

/****************************************************************************
*                            CaffinityDlg::OnAffn
* Inputs:
*       UINT id: ignored
* Result: void
*       
* Effect: 
*       Updates the controls based on a change in the affinity mask
****************************************************************************/

void CaffinityDlg::OnAff1(UINT id)
    {
     ThreadInfo[0].ChangeAffinityMask();
     updateControls();
    }

void CaffinityDlg::OnAff2(UINT id)
    {
     ThreadInfo[1].ChangeAffinityMask();
     updateControls();
    }

void CaffinityDlg::OnAff3(UINT id)
    {
     ThreadInfo[2].ChangeAffinityMask();
     updateControls();
    }

void CaffinityDlg::OnAff4(UINT id)
    {
     ThreadInfo[3].ChangeAffinityMask();
     updateControls();
    }

void CaffinityDlg::OnAff5(UINT id)
    {
     ThreadInfo[4].ChangeAffinityMask();
     updateControls();
    }

void CaffinityDlg::OnAff6(UINT id)
    {
     ThreadInfo[5].ChangeAffinityMask();
     updateControls();
    }

void CaffinityDlg::OnAff7(UINT id)
    {
     ThreadInfo[6].ChangeAffinityMask();
     updateControls();
    }

void CaffinityDlg::OnAff8(UINT id)
    {
     ThreadInfo[7].ChangeAffinityMask();
     updateControls();
    }

void CaffinityDlg::OnGUI(UINT id)
    {
     ThreadInfo[MAX_THREADS].ChangeAffinityMask();
     updateControls();
    }

/****************************************************************************
*              CaffinityDlg::CThreadControl::ChangeAffinityMask
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Sets the affinity mask to be the mask of the current controls
****************************************************************************/

BOOL CaffinityDlg::CThreadControl::ChangeAffinityMask()
    {
     if(!running)
        { /* thread not active */
         SaveProfile();
         return FALSE; // no affinity mask can be set
        } /* thread not active */

     DWORD_PTR newmask = GetAffinityMask();
     DWORD_PTR oldmask = ::SetThreadAffinityMask(thread->m_hThread, newmask);
     if(oldmask == 0)
        { /* failed */
         DWORD err = ::GetLastError();
         Log(new TraceFormatError(index, IDS_MASK_FAILURE, newmask));
         Log(new TraceFormatMessage(index, err));
         return FALSE;
        } /* failed */
     else
        { /* succeeded */
         Log(new TraceFormatComment(index, IDS_MASK_CHANGED, oldmask, newmask));
         SaveProfile();
         return TRUE;
        } /* succeeded */
    } // CaffinityDlg::CThreadControl::ChangeAffinityMask

/****************************************************************************
*                             CaffinityDlg::OnLog
* Inputs:
*       WPARAM: (WPARAM)(TraceEvent *) Trace event
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Logs the message
****************************************************************************/

LRESULT CaffinityDlg::OnLog(WPARAM wParam, LPARAM)
    {
     TraceEvent * e = (TraceEvent *)wParam;
     c_Log.AddString(e);
     return 0;
    } // CaffinityDlg::OnLog

/****************************************************************************
*                     CaffinityDlg::CThreadControl::CanGo
* Result: BOOL
*       TRUE if GO is enabled
****************************************************************************/

BOOL CaffinityDlg::CThreadControl::CanGo()
    {
     return GetAffinityMask() != 0 && !running;
    } // CaffinityDlg::CThreadControl::CanGo

/****************************************************************************
*                        CaffinityDlg::OnBnClickedAll
* Result: void
*       
* Effect: 
*       Starts all the threads
****************************************************************************/

void CaffinityDlg::OnBnClickedAll()
    {
     Log(new TraceComment(TraceEvent::None, IDS_UWM_CLICK_ALL_SENT));
     children.PostMessage(UWM_CLICK_ALL);
     //RunAllWaiting();
    }

/****************************************************************************
*                        CaffinityDlg::OnBnClickedGon
* Result: void
*       
* Effect: 
*       Runs one thread
****************************************************************************/

void CaffinityDlg::OnBnClickedGo1()
    {
     ThreadInfo[0].OnGo();
     updateControls();
     SetupAllWaiting();
     RunAllWaiting();
    }

void CaffinityDlg::OnBnClickedGo2()
    {
     ThreadInfo[1].OnGo();
     updateControls();
     SetupAllWaiting();
     RunAllWaiting();
    }

void CaffinityDlg::OnBnClickedGo3()
    {
     ThreadInfo[2].OnGo();
     updateControls();
     SetupAllWaiting();
     RunAllWaiting();
    }

void CaffinityDlg::OnBnClickedGo4()
    {
     ThreadInfo[3].OnGo();
     updateControls();
     SetupAllWaiting();
     RunAllWaiting();
    }

void CaffinityDlg::OnBnClickedGo5()
    {
     ThreadInfo[4].OnGo();
     updateControls();
     SetupAllWaiting();
     RunAllWaiting();
    }

void CaffinityDlg::OnBnClickedGo6()
    {
     ThreadInfo[5].OnGo();
     updateControls();
     SetupAllWaiting();
     RunAllWaiting();
    }

void CaffinityDlg::OnBnClickedGo7()
    {
     ThreadInfo[6].OnGo();
     updateControls();
     SetupAllWaiting();
     RunAllWaiting();
    }

void CaffinityDlg::OnBnClickedGo8()
    {
     ThreadInfo[7].OnGo();
     updateControls();
     SetupAllWaiting();
     RunAllWaiting();
    }

/****************************************************************************
*                         CaffinityDlg::SetupAllWaiting
* Result: void
*       
* Effect: 
*       Sets up threads ready for release
****************************************************************************/

void CaffinityDlg::SetupAllWaiting()
    {
     for(INT_PTR i = 0; i < graphs.GetSize(); i++)
        graphs[i]->Clear();

     DWORD_PTR mask = ThreadInfo[MAX_THREADS].GetAffinityMask();
     if(mask != 0)
        ::SetThreadAffinityMask(::GetCurrentThread(), mask);
     else
        { /* warn user */
         Log(new TraceError(TraceEvent::None, IDS_GUI_AFFINITY_NOT_SET));
        } /* warn user */

     // Now set the process priority class
     SetPriorityClass(c_ProcessPriority.GetCurPriority(), c_ProcessPriority.GetCurPriorityName());

     // We will set the GUI thread priority to be "time critical" during the
     // launch and then, if we need to drop it, we will do so
     // This will reduce perturbations during the launch

     SetGUIThreadPriority(THREAD_PRIORITY_TIME_CRITICAL, IDS_THREAD_PRIORITY_TIME_CRITICAL);

     // Note that in an ideal world we might consider sorting this list and
     // launching the lowest-priority threads first, but by making the GUI thread
     // be time-critical during this period we probably don't need this additional
     // mechanism

     //****************************************************************
     // Set the parameters for the graph display
     //****************************************************************
     // Set the GRAPHINFO
     //****************************************************************
     GRAPHINFO graphInfo;

     graphInfo.SetProcessPriority(c_ProcessPriority.GetCurPriorityName());
     int sel = c_TestLength.GetCurSel();
     if(sel != CB_ERR)
        { /* has test size */
         CString s;
         c_TestLength.GetLBText(sel, s);
         graphInfo.SetTestSize(s);
        } /* has test size */
     sel = c_Configurations.GetCurSel();
     if(sel != CB_ERR)
        { /* has configuration */
         CString s;
         c_Configurations.GetLBText(sel, s);
         graphInfo.SetConfiguration(s);
        } /* has configuration */

     COPYDATASTRUCT cds = {0};
     cds.lpData = &graphInfo;
     cds.cbData = sizeof(GRAPHINFO);
     cds.dwData = CopyDataTypes::GraphInfo;
     graphInfo.guid = CopyGUID;
     graphInfo.hWnd = m_hWnd;
     ::SendMessage(MasterController, WM_COPYDATA, (WPARAM)m_hWnd, (LPARAM)&cds);
     
     //****************************************************************
     // Set the THREADINFO for each thread

     for(int i = 0; i < MAX_THREADS; i++)
        { /* notify each thread */
         THREADINFO threadInfo;
         threadInfo = ThreadInfo[i].GetThreadInfo(); 
         threadInfo.guid = CopyGUID;
         threadInfo.hWnd = m_hWnd;
         COPYDATASTRUCT cds = {0};
         cds.lpData = &threadInfo;
         cds.cbData = sizeof(THREADINFO);
         cds.dwData = CopyDataTypes::ThreadInfo;
         ::SendMessage(MasterController, WM_COPYDATA, (WPARAM)m_hWnd, (LPARAM)&cds);
        } /* notify each thread */

    } // CaffinityDlg::SetupAllWaiting

/****************************************************************************
*                 CaffinityDlg::CThreadControl::GetThreadInfo
* Result: THREADINFO
*       A partially-filled in THREADINFO structure (only the thread-specific
*       data is filled in)
****************************************************************************/

THREADINFO CaffinityDlg::CThreadControl::GetThreadInfo()
    {
     THREADINFO info;
     info.SetIndex(index);
     info.SetAffinity(GetAffinityMask());
     info.SetPriority(GetPriorityName());
     return info;
    } // CaffinityDlg::CThreadControl::GetThreadInfo

/****************************************************************************
*                     CaffinityDlg::CThreadControl::OnGo
* Result: void
*       
* Effect: 
*       Starts the thread
****************************************************************************/

void CaffinityDlg::CThreadControl::OnGo()
    {
     if(running)
        { /* why are we here? */
         ASSERT(FALSE);
         return;
        } /* why are we here? */

     c_Progress.SetPos(0);
     c_Time.SetWindowText(_T(""));
     ClearGraph();

     if(!CanGo())
        return;

     thread = AfxBeginThread(runthread, this, THREAD_PRIORITY_NORMAL, 0, CREATE_SUSPENDED);
     if(thread != NULL)
        { /* started */
         thread->m_bAutoDelete = FALSE;
         running = TRUE;
         CString s;

         s.Format(_T("%p"), thread->m_hThread);
         c_ThreadHandle.SetWindowText(s);

         s.Format(_T("%x"), thread->m_nThreadID);
         c_ThreadID.SetWindowText(s);

         if(!ChangeAffinityMask())
            running = FALSE;
         if(!ChangeThreadPriority())
            running = FALSE;
         updateControls();
        } /* started */
     else
        { /* failed */
         DWORD err = ::GetLastError();
         Log(new TraceError(index, IDS_THREAD_FAILED));
         Log(new TraceFormatMessage(index, err));
        } /* failed */
    } // CaffinityDlg::CThreadControl::OnGo

/****************************************************************************
*                CaffinityDlg::CThreadControl::GetPriority
* Result: int
*       The priority of the current selection for this thread
****************************************************************************/

int CaffinityDlg::CThreadControl::GetPriority()
    {
     return c_Priority.GetCurPriority();     
    } // CaffinityDlg::CThreadControl::GetPriority

/****************************************************************************
*                CaffinityDlg::CThreadControl::GetPriorityName
* Result: CString
*       The print name of the priority
****************************************************************************/

CString CaffinityDlg::CThreadControl::GetPriorityName()
    {
     return c_Priority.GetCurPriorityName();
    } // CaffinityDlg::CThreadControl::GetPriorityName

/****************************************************************************
*             CaffinityDlg::CThreadControl::ChangeThreadPriority
* Result: BOOL
*       TRUE if successful
* Effect: 
*       Changes the thread priority
****************************************************************************/

BOOL CaffinityDlg::CThreadControl::ChangeThreadPriority()
    {
     if(!running)
        { /* why are we here */
         return FALSE;
        } /* why are we here */

     CString priname = c_Priority.GetCurPriorityName();
     int pri = c_Priority.GetCurPriority();
     if(!::SetThreadPriority(thread->m_hThread, pri))
        { /* failed */
         DWORD err = ::GetLastError();
         Log(new TraceFormatError(index, IDS_CANNOT_SET_PRIORITY, priname));
         Log(new TraceFormatMessage(index, err));
         return FALSE;
        } /* failed */
     else
        { /* changed it */
         Log(new TraceFormatComment(index, IDS_SET_PRIORITY, priname));
         linecolor = PriorityColors::GetBkColor(pri);
         c_Progress.SendMessage(PBM_SETBARCOLOR, 0, linecolor);
         priority = pri;
         return TRUE;
        } /* changed it */
    } // CaffinityDlg::CThreadControl::ChangeThreadPriority

/****************************************************************************
*                 CaffinityDlg::OnCbnSelendokProcessPriority
* Result: void
*       
* Effect: 
*       Notices the change in the controls
****************************************************************************/

void CaffinityDlg::OnCbnSelendokProcessPriority()
    {
     updateControls();
     SaveProfile();
    }

/****************************************************************************
*                           CaffinityDlg::OnStopped
* Inputs:
*       WPARAM: (WPARAM)(CaffinityDlg::CThreadControl *)
*       LPARAM: wall clock time in ms the thread executed
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Logs the fact the thread has stopped
****************************************************************************/

LRESULT CaffinityDlg::OnStopped(WPARAM wParam, LPARAM lParam)
    {
     CaffinityDlg::CThreadControl * t = (CaffinityDlg::CThreadControl *)wParam;
     // We don't want to perturb the behavior by doing anything at this
     // point, so we should really queue the finished request up until all threads are finished
     t->Finished(lParam);

     // This would be deferred to the queue if we implement the above queueing mechanism
     if(InterlockedDecrement(&threadcount) == 0)
        { /* all done */
         SetGUIThreadPriority(THREAD_PRIORITY_NORMAL, IDS_THREAD_PRIORITY_NORMAL);
         ::SetThreadAffinityMask(::GetCurrentThread(), systemAffinityMask);
         CString name;
         name.LoadString(IDS_NORMAL_PRIORITY_CLASS);
         SetPriorityClass(NORMAL_PRIORITY_CLASS, name);
         Log(new TraceFormatComment(TraceEvent::None, IDS_UWM_REQUEST_PLOT_SENT, m_hWnd));
         ::PostMessage(MasterController, UWM_REQUEST_PLOT, 0, (LPARAM)m_hWnd);
         updateControls();
        } /* all done */

     return 0;
    } // CaffinityDlg::OnStopped

/****************************************************************************
*                   CaffinityDlg::CThreadControl::Finished
* Inputs:
*       LPARAM time: Time spent in thread
* Result: void
*       
* Effect: 
*       CLeans up after thread finishes
****************************************************************************/

void CaffinityDlg::CThreadControl::Finished(LPARAM time)
    {
     Log(new TraceComment(index, IDS_THREAD_STOPPED));
     switch(::WaitForSingleObject(thread->m_hThread, INFINITE))
        { /* why wait */
         case WAIT_TIMEOUT:
            ASSERT(FALSE); // fix this if we change from INFINITE
            break;
         case WAIT_OBJECT_0:
            break;
         default:
            ASSERT(FALSE); // something bad happened
            break;
        } /* why wait */
     CString s;
     if(time < 1000)
        { /* ms */
         s.Format(_T("%dms"), time);
        } /* ms */
     else
        { /* seconds */
         s.Format(_T("%d.%03ds"), time / 1000, time % 1000);
        } /* seconds */
     c_Time.SetWindowText(s);
     delete thread;
     thread = NULL;
     running = FALSE;
     c_ThreadHandle.SetWindowText(_T(""));
     c_ThreadID.SetWindowText(_T(""));
     updateControls();
    } // CaffinityDlg::CThreadControl::Finished

/****************************************************************************
*                     CaffinityDlg::SetGUIThreadPriority
* Inputs:
*       int priority: Desired priority
*       const CString & name: Name of priority
* Result: void
*       
* Effect: 
*       Sets the GUI thread priority
****************************************************************************/

void CaffinityDlg::SetGUIThreadPriority(int priority, const CString & name)
    {
     if(!::SetThreadPriority(::GetCurrentThread(), priority))
        { /* failed to change */
         DWORD err = ::GetLastError();
         Log(new TraceFormatError(TraceEvent::None, IDS_CANNOT_SET_PRIORITY, name));
         Log(new TraceFormatMessage(TraceEvent::None, err));

        } /* failed to change */
     else
        { /* changed */
         Log(new TraceFormatComment(TraceEvent::None, IDS_SET_PRIORITY, name));
        } /* changed */
     
    } // CaffinityDlg::SetGUIThreadPriority

/****************************************************************************
*                     CaffinityDlg::SetGUIThreadPriority
* Inputs:
*       int priority:
*       UINT id:
* Result: void
*       
* Effect: 
*       Sets the thread priority
****************************************************************************/

void CaffinityDlg::SetGUIThreadPriority(int priority, UINT id)
    {
     CString s;
     s.LoadString(id);
     SetGUIThreadPriority(priority, s);
    } // CaffinityDlg::SetGUIThreadPriority

/****************************************************************************
*                       CaffinityDlg::SetPriorityClass
* Inputs:
*       DWORD priority: Desired priority
*       const CString & name: Priority name
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Sets the process priority class
****************************************************************************/

BOOL CaffinityDlg::SetPriorityClass(DWORD priority, const CString & name)
    {
     if(!::SetPriorityClass(::GetCurrentProcess(), priority))
        { /* failed */
         DWORD err = ::GetLastError();
         Log(new TraceFormatError(TraceEvent::None, IDS_PROCESS_PRIORITY_FAILED, name, priority));
         Log(new TraceFormatMessage(TraceEvent::None, err));
         return FALSE;
        } /* failed */
     else
        { /* succeeded */
         Log(new TraceFormatComment(TraceEvent::None, IDS_PROCESS_PRIORITY_SET, name, priority));
         return TRUE;
        } /* succeeded */
    } // CaffinityDlg::SetPriorityClass

/****************************************************************************
*                         CaffinityDlg::RunAllWaiting
* Result: void
*       
* Effect: 
*       Immediately dispatches all threads that are feasible to run
****************************************************************************/

void CaffinityDlg::RunAllWaiting()
    {
     int guipriority = ThreadInfo[MAX_THREADS].GetPriority();
     CString guipriorityname = ThreadInfo[MAX_THREADS].GetPriorityName();

     for(int i = 0; i < MAX_THREADS; i++)
        { /* launch all threads */
         if(ThreadInfo[i].HasThread())
            { /* launch thread */
             InterlockedIncrement(&threadcount);
             ThreadInfo[i].RunWaiting();
            } /* launch thread */
        } /* launch all threads */

     SetGUIThreadPriority(guipriority, guipriorityname);
    } // CaffinityDlg::RunAllWaiting

/****************************************************************************
*                  CaffinityDlg::CThreadControl::RunWaiting
* Result: void
*       
* Effect: 
*       If there is a thread waiting, run it
****************************************************************************/

void CaffinityDlg::CThreadControl::RunWaiting()
    {
     start = ::GetTickCount();  // we want the "start" to be when we ACTIVATE the thread!
     if(thread != NULL)
        thread->ResumeThread();
    } // CaffinityDlg::CThreadControl::RunWaiting

/****************************************************************************
*                   CaffinityDlg::CThreadControl::HasThread
* Result: BOOL
*       TRUE if a thread exists
****************************************************************************/

BOOL CaffinityDlg::CThreadControl::HasThread()
    {
     return thread != NULL;
    } // CaffinityDlg::CThreadControl::HasThread

/****************************************************************************
*                  CaffinityDlg::CThreadControl::ClearGraph
* Result: void
*       
* Effect: 
*       Clears the graph
****************************************************************************/

void CaffinityDlg::CThreadControl::ClearGraph()
    {
     for(INT_PTR i = 0; i < graph.GetSize(); i++)
        delete graph[i];
     graph.SetSize(0);
    } // CaffinityDlg::CThreadControl::ClearGraph

/****************************************************************************
*                         CaffinityDlg::PlotAllValues
* Result: void
*       
* Effect: 
*       Plots all the values.  Separates the information out by threadID and
*       thread index
****************************************************************************/

void CaffinityDlg::PlotAllValues()
    {
     for(INT_PTR i = 0; i < graphs.GetSize(); i++)
        { /* show each */
         graphs[i]->Plot();
        } /* show each */
    } // CaffinityDlg::PlotAllValues

/****************************************************************************
*                  CaffinityDlg::CThreadControl::AddPlotData
* Inputs:
*       CGraph & graph: Graph control
* Result: void
*       
* Effect: 
*       Adds the plot data (if any) to the graph
****************************************************************************/

void CaffinityDlg::CThreadControl::AddPlotData(CGraph & ctl)
    {
     for(INT_PTR i = 0; i < graph.GetSize(); i++)
        { /* add each point */
         ctl.AddPoint(index, linecolor, CPoint(graph[i]->time, graph[i]->pos));
        } /* add each point */
    } // CaffinityDlg::CThreadControl::AddPlotData

/****************************************************************************
*                           CaffinityDlg::OnDestroy
* Result: void
*       
* Effect: 
*       Clears up anything that has been allocated
****************************************************************************/

void CaffinityDlg::OnDestroy()
    {
     CDialog::OnDestroy();

     for(int i = 0; i < MAX_THREADS; i++)
        ThreadInfo[i].ClearGraph();

     if(MasterController != NULL && MasterController != STARTUP_FAILURE_HWND && MasterController != m_hWnd)
        { /* send notification */
         Log(new TraceFormatComment(TraceEvent::None, IDS_UWM_PROCESS_NOTIFICATION_SENT, _T("false"), m_hWnd));
         ::PostMessage(MasterController, UWM_PROCESS_NOTIFICATION, (WPARAM)FALSE, (LPARAM)m_hWnd);
        } /* send notification */     
    }

/****************************************************************************
*                        CaffinityDlg::ResizeCopyRect
* Result: void
*       
* Effect: 
*       Resizes the copy rectangle to encompass all the windows
****************************************************************************/

void CaffinityDlg::ResizeCopyRect()
    {
     CRect copyRect(0,0,0,0);
     CRect r;

     graphs[0]->GetWindowRect(&r);
     ScreenToClient(&r);
     copyRect.left = r.left;
     copyRect.top = r.top;

     graphs[graphs.GetSize() - 1]->GetWindowRect(&r);
     ScreenToClient(&r);
     copyRect.right = r.right;
     copyRect.bottom = r.bottom;
     c_CopyRect.MoveWindow(&copyRect);
    } // CaffinityDlg::ResizeCopyRect

/****************************************************************************
*                          CaffinityDlg::OnMouseMove
* Inputs:
*       UINT nFlags:
*       CPoint point:
* Result: void
*       
* Effect: 
*       If in drag mode, drags the window sizes
****************************************************************************/
static int MIN_DRAG_SIZE = (3 * ::GetSystemMetrics(SM_CYCAPTION));

void CaffinityDlg::OnMouseMove(UINT nFlags, CPoint point)
    {
     if(Primary && GetCapture() != NULL)
        { /* can drag */
         CRect r;
         GetClientRect(&r);
         if(point.x < r.left + MIN_DRAG_SIZE)
            return;
         if(point.x > r.right - MIN_DRAG_SIZE)
            return;

         // We can move it
         CRect L;
         c_Log.GetWindowRect(&L);
         ScreenToClient(&L);

         c_Log.SetWindowPos(NULL,
                            0, 0,
                            point.x - dxl, L.Height(),
                            SWP_NOMOVE | SWP_NOZORDER);

         for(INT_PTR i = 0; i < graphs.GetSize(); i++)
            { /* move each */
             CRect G;
             graphs[i]->GetWindowRect(&G);
             ScreenToClient(&G);

             graphs[i]->SetWindowPos(NULL,
                                     point.x + dxr,
                                     L.top,
                                     r.right - (point.x + dxr),
                                     L.Height(),
                                     SWP_NOZORDER);
             graphs[i]->Invalidate();
            } /* move each */
         // Now resize the copy rectangle
         ResizeCopyRect();
        } /* can drag */
    CDialog::OnMouseMove(nFlags, point);
    }

/****************************************************************************
*                        CaffinityDlg::TryLButtonDown
* Inputs:
*       CPoint pt: Point to test
* Result: BOOL
*       TRUE if we can start drag
*       FALSE if we can't
* Effect: 
*       Sets capture if we can start a drag
****************************************************************************/

BOOL CaffinityDlg::TryLButtonDown(CPoint pt)
    {
     if(!Primary)
        return FALSE;

     if(!InSplitterArea(pt))
        return FALSE;

     CRect L;
     c_Log.GetWindowRect(&L);
     ScreenToClient(&L);
     
     CRect G;
     graphs[0]->GetWindowRect(&G);
     ScreenToClient(&G);
     
     SetCapture();
     dxl = pt.x - L.right;
     dxr = G.left - pt.x;
     return TRUE;
    } // CaffinityDlg::TryLButtonDown

/****************************************************************************
*                         CaffinityDlg::OnLButtonDown
* Inputs:
*       UINT nFlags: ignored
*       CPoint point:
* Result: void
*       
* Effect: 
*       If the mouse is in the resizing area, initiates a drag operation
****************************************************************************/

void CaffinityDlg::OnLButtonDown(UINT nFlags, CPoint point)
    {
     if(TryLButtonDown(point))
        return;
    CDialog::OnLButtonDown(nFlags, point);
    }

/****************************************************************************
*                          CaffinityDlg::OnLButtonUp
* Inputs:
*       UINT nFlags: ignored
*       CPoint point:
* Result: void
*       
* Effect: 
*       Releases capture
****************************************************************************/

void CaffinityDlg::OnLButtonUp(UINT nFlags, CPoint point)
    {
     if(GetCapture() != NULL)
        ReleaseCapture();
     
     CDialog::OnLButtonUp(nFlags, point);
    }

/****************************************************************************
*                          CaffinityDlg::ResizeGraphs
* Result: void
*       
* Effect: 
*       Lays out the graphs
****************************************************************************/

void CaffinityDlg::ResizeGraphs()
    {
     CRect client;
     GetClientRect(&client);

     int hgap = 3 * ::GetSystemMetrics(SM_CXEDGE);
     int vgap = 2 * ::GetSystemMetrics(SM_CXEDGE);


     if(Primary && graphs.GetSize() > 0)
        { /* resize graph */

         CRect L;
         c_Log.GetWindowRect(&L);
         ScreenToClient(&L);

         //****************************************************************
         //     +--------------+   ------------------
         //     | h            |             ^
         //     +--------------+             |
         //                      vgap        |
         //     +--------------+             |
         //     | h            |             L.GetHeight();
         //     +--------------+             |
         //                      vgap        |
         //     +--------------+             |
         //     | h            |             V
         //     +--------------+   ------------------
         //
         //     h = (L.GetHeight() - (n -1)*vgap) / n
         //****************************************************************

         int h;
         if(graphs.GetSize() > 0)
            h = (L.Height() - (int)(graphs.GetSize() - 1) * vgap) / (int)graphs.GetSize();
         else
            h = L.Height();
         int offset = 0;

         for(int i = 0; i < graphs.GetSize(); i++)
            { /* resize each graph */
             CRect G;
             graphs[i]->GetWindowRect(&G);
             ScreenToClient(&G);
             graphs[i]->SetWindowPos(NULL,
                                     G.left,                             // x-coordinate
                                     L.top + offset,                     // y-coordinate
                                     client.Width() - (L.right + hgap),  // width
                                     h,                                  // height
                                     SWP_NOZORDER);
             offset += h + vgap;

             graphs[i]->Invalidate();
            } /* resize each graph */

         ResizeCopyRect();
        } /* resize graph */
     
    } // CaffinityDlg::ResizeGraphs

/****************************************************************************
*                            CaffinityDlg::OnSize
* Inputs:
*       UINT nType: Sizing type
*       int cx: New client width
*       int cy: New client height
* Result: void
*       
* Effect: 
*       Resizes the child controls
****************************************************************************/

void CaffinityDlg::OnSize(UINT nType, int cx, int cy)
    {
     CDialog::OnSize(nType, cx, cy);

     //****************************************************************
     // Resize the log
     //****************************************************************
     if(c_Log.GetSafeHwnd() != NULL)
        { /* resize log */
         CRect w;
         // If we are the primary, we will want to allow space for
         // the graph
         // If we are not the primary, the log occupies the entire
         // bottom part of the dialog
         // Note that if we widen the window, we will be extending
         // the graph, not the log window, which will remain
         // no wider than the current one is.
         c_Log.GetWindowRect(&w);
         ScreenToClient(&w);

         if(!Primary)
            GetClientRect(&w);

         c_Log.SetWindowPos(NULL,
                            0, 0,
                            w.Width(), cy - w.top,
                            SWP_NOMOVE | SWP_NOZORDER);
        } /* resize log */

     ResizeGraphs();

     // Compute the positions of all the buttons that
     // move dynamically
     int gap = 3 * ::GetSystemMetrics(SM_CXEDGE);

     //****************************************************************
     // c_CopyAll: Copies the entire client area of the dialog
     // stays positioned at the right (top) of the dialog
     //****************************************************************
     if(c_CopyAll.GetSafeHwnd() != NULL)
        { /* move copy-all */
         CRect C;
         c_CopyAll.GetWindowRect(&C);
         ScreenToClient(&C);
         c_CopyAll.SetWindowPos(NULL,
                                cx - (C.Width() + gap),
                                C.top,
                                0,0,
                                SWP_NOSIZE | SWP_NOZORDER);
        } /* move copy-all */

     //****************************************************************
     // c_Copy: Copies the graph
     // stays positioned with the right end of the graph window
     //****************************************************************
     if(c_Copy.GetSafeHwnd() != NULL  && graphs.GetSize() > 0)
        { /* move copy */
         CRect G;
         graphs[0]->GetWindowRect(&G);
         ScreenToClient(&G);

         CRect C;
         c_Copy.GetWindowRect(&C);
         ScreenToClient(&C);

         c_Copy.SetWindowPos(NULL,
                             cx - (C.Width() + gap),
                             C.top,
                             0,0,
                             SWP_NOSIZE | SWP_NOZORDER);
        } /* move copy */
    }

/****************************************************************************
*                        CaffinityDlg::InSplitterArea
* Inputs:
*       CPoint cur: Point where cursor is found, in client coordinates
* Result: BOOL
*       TRUE if the mouse is in the splitter area
*       FALSE if the mouse is outside the splitter area
* Notes: 
*       +--------------------------------------------------------+
*       |                          <A>                           |
*       |                                                        |
*       |                                                        |
*       |L                                      G                |
*       |+-----------------------------------+##+---------------+|
*       ||              c_Log      <B>       |##| graphs[0] <C> ||
*       |+-----------------------------------+##+---------------+|
*       +--------------------------------------------------------+
****************************************************************************/

BOOL CaffinityDlg::InSplitterArea(CPoint cur)
    {
     CRect L;
     c_Log.GetWindowRect(&L);
     ScreenToClient(&L);

     if(cur.y < L.top)
        return FALSE; // in area <A>

     if(cur.x < L.right)
        return FALSE; // in area <B>

     if(graphs.GetSize() == 0)
        return FALSE;

     CRect G;
     graphs[0]->GetWindowRect(&G);
     ScreenToClient(&G);
     if(cur.x > G.left)
        return FALSE;   // in area <C>
     return TRUE;  // none of the above, must be in splitter bar
    } // CaffinityDlg::InSplitterArea

/****************************************************************************
*                         CaffinityDlg::TrySetCursor
* Inputs:
*       UINT nHitTest:
* Result: BOOL
*       TRUE if we set the cursor
*       FALSE if we didn't
* Effect: 
*       Sets the drag cursor if we are in the drag area
****************************************************************************/

BOOL CaffinityDlg::TrySetCursor(UINT nHitTest)
    {
     if(nHitTest != HTCLIENT)
        return FALSE;

     CPoint cur;
     ::GetCursorPos(&cur);
     ScreenToClient(&cur);

     if(!InSplitterArea(cur))
        return FALSE;

     HCURSOR drag = AfxGetApp()->LoadCursor(IDC_RESIZER);
     ::SetCursor(drag);
     return TRUE;
    } // CaffinityDlg::TrySetCursor

/****************************************************************************
*                          CaffinityDlg::OnSetCursor
* Inputs:
*       CWnd * pWnd: ignored, except to pass to superclass
*       UINT nHitTest: interesting if HTCLIENT, otherwise passed to superclass
*       UINT msg: ignored, except to pass to superclass
* Result: BOOL
*       TRUE if cursor has been set
*       FALSE otherwise
* Effect: 
*       Sets the drag cursor if we are in the drag area
****************************************************************************/

BOOL CaffinityDlg::OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message)
    {
     if(TrySetCursor(nHitTest))
        return TRUE;

     return CDialog::OnSetCursor(pWnd, nHitTest, message);
    }

/****************************************************************************
*                        CaffinityDlg::OnBnClickedCopy
* Result: void
*       
* Effect: 
*       Copies the graph to the clipboard
****************************************************************************/

void CaffinityDlg::OnBnClickedCopy()
    {
     toClipboard(&c_CopyRect);
    }

/****************************************************************************
*                    CaffinityDlg::OnCbnSelendokTestLength
* Result: void
*       
* Effect: 
*       Changes the iteration length
****************************************************************************/

void CaffinityDlg::OnCbnSelendokTestLength()
    {
     DWORD_PTR len = c_TestLength.GetCurItem();
     ASSERT(len != 0);
     SetAllIterations((DWORD)len);
     SaveProfile();
    }

/****************************************************************************
*                       CaffinityDlg::SetAllIterations
* Inputs:
*       DWORD len: Number of iterations to set
* Result: void
*       
* Effect: 
*       Sets the iteration count for all threads
****************************************************************************/

void CaffinityDlg::SetAllIterations(DWORD len)
    {
     for(int i = 0; i < MAX_THREADS; i++)
        ThreadInfo[i].SetIterations(len);
    } // CaffinityDlg::SetAllIterations

/****************************************************************************
*                         CaffinityDlg::OnAnyRunning
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       (LRESULT)TRUE if any thread is running
*       (LRESULT)FALSE if no thread is running
****************************************************************************/

LRESULT CaffinityDlg::OnAnyRunning(WPARAM, LPARAM)
    {
     for(int i = 0; i < MAX_THREADS; i++)
        if(ThreadInfo[i].HasThread())
           return (LRESULT)TRUE;
     return (LRESULT)FALSE;
    } // CaffinityDlg::OnAnyRunning

/****************************************************************************
*                 CaffinityDlg::CThreadControl::EnablePriority
* Inputs:
*       BOOL m: Mode to set
* Result: void
*       
* Effect: 
*       Enables/disables the priority window
****************************************************************************/

void CaffinityDlg::CThreadControl::EnablePriority(BOOL m)
    {
     c_Priority.EnableWindow(m);
    } // CaffinityDlg::CThreadControl::EnablePriority

/****************************************************************************
*                           CaffinityDlg::OnBnClickedCopyAll
* Result: void
*       
* Effect: 
*       Copies the dialog
****************************************************************************/

void CaffinityDlg::OnBnClickedCopyall()
    {
     c_CopyAll.ShowWindow(SW_HIDE);
     toClipboard(this);
     c_CopyAll.ShowWindow(SW_SHOW);
    }

/****************************************************************************
*                            CaffinityDlg::OnStop
* Result: void
*       
* Effect: 
*       Stops all running threads
****************************************************************************/

void CaffinityDlg::OnBnClickedStop()
    {
     for(int i = 0; i < MAX_THREADS; i++)
        ThreadInfo[i].Stop();
    }

/****************************************************************************
*                        CaffinityDlg::OnGetMinMaxInfo
* Inputs:
*       MINMAXINFO * lpMMI:
* Result: void
*       
* Effect: 
*       Prevents resizing the dialog to hide any controls
****************************************************************************/

void CaffinityDlg::OnGetMinMaxInfo(MINMAXINFO* lpMMI)
    {
     if(c_Frame.GetSafeHwnd() != NULL)
        { /* can limit */
         CRect r;
         c_Frame.GetWindowRect(&r);
         ScreenToClient(&r);
         CalcWindowRect(&r);
         lpMMI->ptMinTrackSize.x = r.Width();
         lpMMI->ptMinTrackSize.y = r.Height();
         return;
        } /* can limit */
     CDialog::OnGetMinMaxInfo(lpMMI);
    }

/****************************************************************************
*                      CaffinityDlg::OnBnClickedResetAll
* Result: void
*       
* Effect: 
*       Sets all the controls back to an initial state
****************************************************************************/

void CaffinityDlg::OnBnClickedResetAll()
    {
     //****************
     // Process priority
     //****************
     c_ProcessPriority.Select(NORMAL_PRIORITY_CLASS);

     //****************
     // all threads
     //****************
     for(int i = 0; i < MAX_THREADS+1; i++) // includes GUI thread
        ThreadInfo[i].ResetControls();

     //****************
     // Set GUI affinity mask
     //****************
     ThreadInfo[MAX_THREADS].SetAffinityMask(systemAffinityMask); // GUI runs everywhere

     //****************
     // Test length
     //****************
     c_TestLength.Select(DEFAULT_ITERATIONS);

     updateControls();
     SaveProfile();
    }

/****************************************************************************
*                     CaffinityDlg::SaveConfigurationName
* Result: void
*       
* Effect: 
*       Saves the configuration name as the default statup configuration
****************************************************************************/

void CaffinityDlg::SaveConfigurationName()
    {
     CString cfg = GetConfiguration();

     RegistryStringEx curcfg(IDS_REGISTRY_CURRENT_CONFIGURATION, MakeInstancePrefix());
     if(cfg.IsEmpty())
        { /* no config */
         curcfg.Delete(); // remove the key
        } /* no config */
     else
        { /* save it */
         curcfg.value = cfg;
         VERIFY(curcfg.store());
        } /* save it */
    } // CaffinityDlg::SaveConfigurationName

/****************************************************************************
*                          CaffinityDlg::SaveProfile
* Result: void
*       
* Effect: 
*       Saves values to the Registry
* Notes:
*       IDS_PROGRAM_ROOT\
*          +
*          |
*          +--- Process Priority: REG_DWORD  [IDS_REGISTRY_PROCESS_PRIORITY]
*          |
*          +--- Test size: REG_DWORD
*          |
*          +--- Threads
*                  |
*                  +---0
*                  |   |
*                  |   +--- AffinityMask: REG_QWORD
*                  |   |
*                  |   +--- ThreadPriority: REG_DWORD
*                  |
*                  +---1
*                  |   |
*                  |   +--- AffinityMask: REG_QWORD
*                  |   |
*                  |   +--- ThreadPriority: REG_DWORD
*                  :
*                  +---GUI
*                      |
*                      +--- AffinityMask: REG_QWORD
*                      |
*                      +--- ThreadPriority: REG_DWORD
****************************************************************************/

void CaffinityDlg::SaveProfile()
    {
     CString cfg = GetConfiguration();

     Log(new TraceFormatComment(TraceEvent::None, IDS_SAVING_PROFILE, cfg));

     //***************************************
     // Configuration name (instance-relative)
     //***************************************
     SaveConfigurationName();

     //******************************************
     // Process priority (configuration-relative)
     //******************************************
     // IDS_PROGRAM_ROOT\IDS_REGISTRY_CONFIGURATIONS\Configuration\GetConfiguration()\IDS_REGISTRY_PROCESS_PRIORITY
     RegistryIntEx procpri(IDS_REGISTRY_PROCESS_PRIORITY, MakeConfigPrefix());
     procpri.value = c_ProcessPriority.GetCurPriority();
     VERIFY(procpri.store());

     //***************************************
     // ...\Test size (configuration-relative)
     //***************************************
     RegistryIntEx testsize(IDS_REGISTRY_TEST_SIZE, MakeConfigPrefix());
     DWORD_PTR v = c_TestLength.GetCurItem();
     if(v == 0)
        testsize.Delete(); // should actually never happen...
     else
        { /* save test size */
         testsize.value = (int)v;
         VERIFY(testsize.store());
        } /* save test size */

     //**************************************
     // Threads data (configuration-relative)
     //**************************************
     for(int i = 0; i < MAX_THREADS + 1; i++) // includes the GUI thread
        ThreadInfo[i].SaveProfile();

     Log(new TraceComment(TraceEvent::None, IDS_PROFILE_SAVED));
    } // CaffinityDlg::SaveProfile

/****************************************************************************
*                      CaffinityDlg::MakeInstancePrefix
* Result: CString
*       if /seq: is specified:  seq
*       if /seq: is not specified: empty string
****************************************************************************/

CString CaffinityDlg::MakeInstancePrefix()
    {
     CString key;
     key = GetCommandParameter(_T("seq"));
     return key;
    } // CaffinityDlg::MakeInstancePrefix

/****************************************************************************
*                       CaffinityDlg::MakeConfigPrefix
* Result: CString
*       Configurations\GetConfiguration()
****************************************************************************/

CString CaffinityDlg::MakeConfigPrefix()
    {
     CString key;
     key.LoadString(IDS_REGISTRY_CONFIGURATIONS);
     key += _T("\\");
     key += GetConfiguration();
     return key;
    } // CaffinityDlg::MakeConfigPrefix

/****************************************************************************
*                          CaffinityDlg::LoadProfile
* Result: void
*       
* Effect: 
*       Loads the profile
****************************************************************************/

void CaffinityDlg::LoadProfile()
    {
     //***************************************
     // ...\Test size (configuration-relative)
     //***************************************
     RegistryIntEx testsize(IDS_REGISTRY_TEST_SIZE, MakeConfigPrefix());
     testsize.load(DEFAULT_ITERATIONS);
     if(c_TestLength.Select(testsize.value) == CB_ERR)
        { /* bogus value */
         testsize.value = DEFAULT_ITERATIONS;
        } /* bogus value */
     SetAllIterations(testsize.value);

     //******************************************
     // Process priority (configuration-relative)
     //******************************************
     
     RegistryIntEx procpri(IDS_REGISTRY_PROCESS_PRIORITY, MakeConfigPrefix());
     procpri.load(NORMAL_PRIORITY_CLASS);

     c_ProcessPriority.Select(procpri.value);

     //**************************************
     // Threads data (configuration-relative)
     //**************************************
     for(int i = 0; i < MAX_THREADS + 1; i++) // includes the GUI thread
        { /* load thread profiles */
         ThreadInfo[i].SetConfiguration(GetConfiguration());
         ThreadInfo[i].LoadProfile();
        } /* load thread profiles */

     //**********************
     // Printer font (global)
     //**********************
     RegistryFont f(IDS_REGISTRY_PRINTER_FONT);
     if(f.load())
        { /* has font */
         c_Log.SetPrinterFont(&f.value);
        } /* has font */
     updateControls();
    } // CaffinityDlg::LoadProfile

/****************************************************************************
*                CaffinityDlg::CThreadControl::MakeRegistryKey
* Result: CString
*       A key name for this thread
*       Either the %d formatting of the thread index, or "GUI"
* Notes:
*                                                   |<-----------------MakeRegistryKey--------------->|
*                        |<----IDS_PROGRAM_ROOT---->|<----cfg----->|<---configName--->|threads|<----threadid---->| variables
*       HKEY_CURRENT_USER\Software\mvp_tips\affinity\Configurations\configuration-name\Threads\thread-index-or-GUI
****************************************************************************/

CString CaffinityDlg::CThreadControl::MakeRegistryKey()
    {
     CString key;
     //************************************************
     // Configurations
     //************************************************
     key.LoadString(IDS_REGISTRY_CONFIGURATIONS);

     //************************************************
     // Configurations\
     //************************************************
     key += _T("\\");

     //************************************************
     // Configurations\configurationame
     //************************************************
     
     CString configName;
     if(!configuration.IsEmpty())
        { /* use configurations */
         configName = configuration;
        } /* use configurations */
     else
        { /* use default */    
         configName.LoadString(IDS_REGISTRY_DEFAULT_CONFIG_NAME);
        } /* use default */

     key += configName;

     //************************************************
     // Configurations\configurationame\
     //************************************************

     key += _T("\\");

     //************************************************
     // Configurations\configurationame\Threads
     //************************************************
     CString threads;
     threads.LoadString(IDS_REGISTRY_THREADS);
     key += threads;
     
     //************************************************
     // Configurations\configurationame\Threads\
     //************************************************

     key += _T("\\");

     //************************************************
     // Configurations\configurationame\Threads\0
     // Configurations\configurationame\Threads\GUI
     //************************************************
     CString threadid;
     if(index == TraceEvent::None)
        threadid = _T("GUI");
     else
        threadid.Format(_T("%d"), index);

     key += threadid;

     return key;
    } // CaffinityDlg::CThreadControl::MakeRegistryKey

/****************************************************************************
*                       CaffinityDlg::GetConfiguration
* Result: CString
*       The current configuration name, or the empty string
****************************************************************************/

CString CaffinityDlg::GetConfiguration()
    {
     CString configuration;
     int cfg = c_Configurations.GetCurSel();
     if(cfg != CB_ERR)
        c_Configurations.GetLBText(cfg, configuration);
     return configuration;
    } // CaffinityDlg::GetConfiguration

/****************************************************************************
*                  CaffinityDlg::CThreadControl::SaveProfile
* Result: void
*       
* Effect: 
*       Stores the profile.  If the index is TraceEvent::None, stores it
*       as the GUI info
* Notes:
*       IDS_PROGRAM_ROOT\
*          :
*          |
*          +--- Configurations
*                 |
*                 +--- name1
*                 |     |
*                 |     +--- Threads
*                 |     |
*                 |     +---0
*                 |     |   |
*                 |     |   +--- AffinityMask: REG_QWORD
*                 |     |   |
*                 |     |   +--- ThreadPriority: REG_DWORD
*                 |     |
*                 |     +---1
*                 |     |   |
*                 |     |   +--- AffinityMask: REG_QWORD
*                 |     |   |
*                 |     |   +--- ThreadPriority: REG_DWORD
*                 |     :
*                 |     +---GUI
*                 |         |
*                 |         +--- AffinityMask: REG_QWORD
*                 |         |
*                 |         +--- ThreadPriority: REG_DWORD
*                 |
*                 +---name2
*                 |      ... etc
*                 |
*                 :
*                 +---namen
****************************************************************************/

void CaffinityDlg::CThreadControl::SaveProfile()
    {
     //****************
     // affinity
     //****************
     CString keyname;
     keyname = MakeRegistryKey();
     VERIFY(SetRegistryInt64(HKEY_CURRENT_USER, keyname, IDS_REGISTRY_AFFINITY, (LONGLONG)GetAffinityMask()));

     //*****************************************
     // thread priority (configuration-relative)
     //*****************************************
     int pri = GetPriority();

     VERIFY(SetRegistryInt(HKEY_CURRENT_USER, keyname, IDS_REGISTRY_THREAD_PRIORITY, pri));
    } // CaffinityDlg::CThreadControl::SaveProfile

/****************************************************************************
*                  CaffinityDlg::CThreadControl::LoadProfile
* Result: void
*       
* Effect: 
*       Loads the profile
****************************************************************************/

void CaffinityDlg::CThreadControl::LoadProfile()
    {
     CString keyname = MakeRegistryKey();
     //**********************************
     // affinity (configuration-relative)
     //**********************************
     LONGLONG aff;
     if(!GetRegistryInt64(HKEY_CURRENT_USER, keyname, IDS_REGISTRY_AFFINITY, aff))
        aff = 0;

     // Note that we have to make sure we haven't stored a mask 'wider'
     // than the actual number of processors!  Mask off by the system
     // affinity mask!
     DWORD_PTR processMask;
     DWORD_PTR systemMask;
     GetProcessAffinityMask(::GetCurrentProcess(), &processMask, &systemMask);

     SetAffinityMask( ((DWORD_PTR)aff) & systemMask);

     //*****************************************
     // thread priority (configuration relative)
     //*****************************************
     
     DWORD pri;
     if(!GetRegistryInt(HKEY_CURRENT_USER, keyname, IDS_REGISTRY_THREAD_PRIORITY, pri))
        pri = THREAD_PRIORITY_NORMAL;
     
     c_Priority.Select(pri);
    } // CaffinityDlg::CThreadControl::LoadProfile

/****************************************************************************
*                       CaffinityDlg::SaveThreadProfile
* Inputs:
*       int n: 
* Result: void
*       
* Effect: 
*       Saves the profile for thread[n]
****************************************************************************/

void CaffinityDlg::SaveThreadProfile(int n)
    {
     ThreadInfo[n].SetConfiguration(GetConfiguration());
     ThreadInfo[n].SaveProfile();
    } // CaffinityDlg::SaveThreadProfile

/****************************************************************************
*                       CaffinityDlg::OnCbnSelendokPri(n)
* Result: void
*       
* Effect: 
*       Forces a profile save
****************************************************************************/

void CaffinityDlg::OnCbnSelendokPri1()
    {
     SaveThreadProfile(0);
    }

void CaffinityDlg::OnCbnSelendokPri2()
    {
     SaveThreadProfile(1);
    }

void CaffinityDlg::OnCbnSelendokPri3()
    {
     SaveThreadProfile(2);
    }

void CaffinityDlg::OnCbnSelendokPri4()
    {
     SaveThreadProfile(3);
    }

void CaffinityDlg::OnCbnSelendokPri5()
    {
     SaveThreadProfile(4);
    }

void CaffinityDlg::OnCbnSelendokPri6()
    {
     SaveThreadProfile(5);
    }

void CaffinityDlg::OnCbnSelendokPri7()
    {
     SaveThreadProfile(6);
    }

void CaffinityDlg::OnCbnSelendokPri8()
    {
     SaveThreadProfile(7);
    }

void CaffinityDlg::OnCbnSelendokGUI()
    {
     SaveThreadProfile(MAX_THREADS);
    }

/****************************************************************************
*                           CaffinityDlg::AddGraph
* Inputs:
*       const CRect & r: Desired rectangle
*       HWND owner: owner of graph
* Result: BOOL
*       TRUE if successful
*       FALSE if error
* Effect: 
*       Creates a new graph
****************************************************************************/

BOOL CaffinityDlg::AddGraph(const CRect & r, HWND owner)
    {
     CGraph * graph = new CGraph;
     if(!graph->Create(r, this))
        return FALSE;
     graph->SetProcess(owner);
     graphs.Add(graph);
     ResizeGraphs();
     return TRUE;
    } // CaffinityDlg::AddGraph

/****************************************************************************
*                          CaffinityDlg::DeleteGraph
* Inputs:
*       HWND owner: Owner of graph
* Result: void
*       
* Effect: 
*       Deletes the graph
****************************************************************************/

void CaffinityDlg::DeleteGraph(HWND owner)
    {
     for(INT_PTR i = 0; i < graphs.GetSize(); i++)
        { /* delete graph */
         if(graphs[i]->GetProcess() == owner)
            { /* found it */
             graphs[i]->DestroyWindow();
             delete graphs[i];
             graphs.RemoveAt(i);
             break;
            } /* found it */
        } /* delete graph */
     ResizeGraphs();
    } // CaffinityDlg::DeleteGraph

/****************************************************************************
*                     CaffinityDlg::OnProcessNotification
* Inputs:
*       WPARAM: (WPARAM)(BOOL) TRUE to add, FALSE to remove
*       LPARAM: (LPARAM)(HWND)the window which is added or terminated
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Handles child processes
****************************************************************************/

LRESULT CaffinityDlg::OnProcessNotification(WPARAM wParam, LPARAM lParam)
    {
     BOOL add = (BOOL)wParam;
     Log(new TraceFormatComment(TraceEvent::None, IDS_UWM_PROCESS_NOTIFICATION_RECEIVED,
                                add ? _T("true") : _T("false"),
                                lParam));
     
     if(add) 
        { /* add a new process */
         //****************************************************************
         // ADD
         //****************************************************************
         ChildProcess proc;
         proc.hWnd = (HWND)lParam;
         children.Add(proc);

         CRect r;
         c_CopyRect.GetWindowRect(&r);
         ScreenToClient(&r);

         AddGraph(r, (HWND)lParam);
        } /* add a new process */
     else
        { /* delete a process */
         //****************************************************************
         // DELETE
         //****************************************************************
         children.Remove((HWND)lParam);
         DeleteGraph((HWND)lParam);
         ResizeGraphs();
         if(children.GetSize() == 1 && closing)
            { /* closing */
             Log(new TraceComment(TraceEvent::None, IDS_ALL_DEFERRED_COMPLETE));
             PostMessage(WM_CLOSE); // try again, now that the limit has been reached
            } /* closing */
        } /* delete a process */
     return 0;
    } // CaffinityDlg::OnProcessNotification

/****************************************************************************
*                                CaffinityDlg::Log
* Inputs:
*       TraceEvent * e: Trace event to log
* Result: void
*       
* Effect: 
*       Posts a message to the log
****************************************************************************/

void CaffinityDlg::Log(TraceEvent * e)
    {
     PostMessage(UWM_LOG, (WPARAM)e);
    } // Log

/****************************************************************************
*                      CaffinityDlg::CThreadControl::Log
* Inputs:
*       TraceEvent * e: Trace event
* Result: void
*       
* Effect: 
*       Posts the message to the parent
****************************************************************************/

void CaffinityDlg::CThreadControl::Log(TraceEvent * e)
    {
     parent->PostMessage(UWM_LOG, (WPARAM)e);
    } // CaffinityDlg::CThreadControl::Log

/****************************************************************************
*                       CaffinityDlg::OnStartupFailure
* Inputs:
*       WPARAM: unused
*       LPARAM: unused
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Notifies the instance that it can't be a secondary instance
****************************************************************************/

LRESULT CaffinityDlg::OnStartupFailure(WPARAM, LPARAM)
    {
     AfxMessageBox(IDS_STARTUP_FAILURE, MB_ICONERROR);
     PostMessage(WM_CLOSE);
     return 0;
    } // CaffinityDlg::OnStartupFailure

/****************************************************************************
*               CaffinityDlg::CThreadControl::SetConfiguration
* Inputs:
*       const CString & s: Configuration name
* Result: void
*       
* Effect: 
*       Changes the configuration name
****************************************************************************/

void CaffinityDlg::CThreadControl::SetConfiguration(const CString & s)
    {
     configuration = s;
    } // CaffinityDlg::CThreadControl::SetConfiguration

/****************************************************************************
*                  CaffinityDlg::OnCbnSelendOKConfiguration
* Result: void
*       
* Effect: 
*       Selects the specified configuration
* Notes:
*       The ItemData of all configurations is 0
*       The ItemData of the <New...> is CONFIGURATION_NEW
****************************************************************************/

void CaffinityDlg::OnCbnSelendokConfiguration()
    {
     int sel = c_Configurations.GetCurSel();
     if(sel == CB_ERR)
        return;

     DWORD item = (DWORD)c_Configurations.GetItemData(sel);
     if(item == CONFIGURATION_NEW)
        { /* new config */
         CNewConfigurationName dlg;
         switch(dlg.DoModal())
            { /* dlg */
             case IDCANCEL:
                { /* reset */
                 if(c_Configurations.GetCount() == 1)
                    { /* logically empty */
                     // If there is only one, it is the <new...> entry
                     // We set the option to have "no" selection in this case
                     c_Configurations.SetCurSel(CB_ERR);
                    } /* logically empty */
                 else
                    { /* more than one */
                     // We canceled out.  Return to the original configuration
                     // we had selected
                     int n = c_Configurations.FindStringExact(-1, configuration);
                     if(n != CB_ERR)
                        { /* revert to existing config */
                         c_Configurations.SetCurSel(n);
                        } /* revert to existing config */
                     else
                        { /* not found */
                         // For now...just reset to a non-selection.  This should be impossible
                         c_Configurations.SetCurSel(CB_ERR);
                        } /* not found */
                    } /* more than one */
                 return;
                } /* reset */
             case IDOK:
                break;
            } /* dlg */

         dlg.m_Name.Trim();
         if(dlg.m_Name.IsEmpty())
            return;

         int n = c_Configurations.FindStringExact(-1, dlg.m_Name);
         if(n == CB_ERR)
            { /* really new name */
             int newcfg = c_Configurations.AddString(dlg.m_Name);
             c_Configurations.SetCurSel(newcfg);
             // Save the configuration for later
             configuration = GetConfiguration();
             SaveProfile(); // save current settings as the new configuration
                            // if the user wants to start over, that's what
                            // the Reset button is for
            } /* really new name */
         else
            { /* name already exists */
             c_Configurations.SetCurSel(n);
             configuration = GetConfiguration();
             SaveConfigurationName();
             LoadProfile();
            } /* name already exists */
        } /* new config */
     else
        { /* change to existing config */
         configuration = GetConfiguration();
         SaveConfigurationName();
         LoadProfile();
        } /* change to existing config */
    }

/****************************************************************************
*                       CaffinityDlg::CopyDataAddPoint
* Inputs:
*       POSINFO * pos
* Result: void
*       
* Effect: 
*       Adds the data point to the appropriate graph
****************************************************************************/

void CaffinityDlg::CopyDataAddPoint(POSINFO * pos)
    {
     // Now figure out which window to add it to
     for(INT_PTR i = 0; i < graphs.GetSize(); i++)
        { /* match each */
         if(graphs[i]->GetProcess() == pos->wnd)
            { /* match */
             graphs[i]->AddPoint(pos->index, pos->priority, CPoint(pos->time, pos->pos));
             return;
            } /* match */
        } /* match each */
    } // CaffinityDlg::CopyDataAddPoint

/****************************************************************************
*                     CaffinityDlg::CopyDataAddGraphInfo
* Inputs:
*       GRAPHINFO * info: Graph information block
* Result: void
*       
* Effect: 
*       Adds graph info to the graph
****************************************************************************/

void CaffinityDlg::CopyDataAddGraphInfo(GRAPHINFO * info)
    {
     for(int i = 0; i < graphs.GetSize(); i++)
        { /* try each */
         if(graphs[i]->GetProcess() == info->hWnd)
            { /* found it */
             graphs[i]->SetGraphInfo(info);
             return;
            } /* found it */
        } /* try each */
     ASSERT(FALSE); // should not get here
    } // CaffinityDlg::CopyDataAddGraphInfo

/****************************************************************************
*                     CaffinityDlg::CopyDataAddThreadInfo
* Inputs:
*       THREADINFO * info: Thread info
* Result: void
*       
* Effect: 
*       Adds thread info data
****************************************************************************/

void CaffinityDlg::CopyDataAddThreadInfo(THREADINFO * info)
    {
     for(int i = 0; i < graphs.GetSize(); i++)
        { /* try each */
         if(graphs[i]->GetProcess() == info->hWnd)
            { /* found it */
             graphs[i]->SetThreadInfo(info);
             return;
            } /* found it */
        } /* try each */
     ASSERT(FALSE); // should not get here
    } // CaffinityDlg::CopyDataAddThreadInfo

/****************************************************************************
*                          CaffinityDlg::OnCopyData
* Inputs:
*       CWnd * pWnd: The sending window
*       COPYDATASTRUCT * pCopyDataStruct
* Result: BOOL
*       TRUE if the data is accepted
*       FALSE if it is not
* Effect: 
*       Used to pass a POSINFO structure across process boundaries (and
*       is used for the local process as well)
****************************************************************************/

BOOL CaffinityDlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct)
    {
     if(!CopyData::Check(pCopyDataStruct))
        return FALSE;
     
     CopyData * data = (CopyData *)pCopyDataStruct->lpData;

     if(!data->Same(CopyGUID))
        return FALSE;

     switch(pCopyDataStruct->dwData)
        { /* what kind of copydata */
         case CopyDataTypes::GraphPoint:
               CopyDataAddPoint((POSINFO *)data);
               return TRUE;  // well, we couldn't use it, but it was *our* data...
         case CopyDataTypes::GraphInfo:
               CopyDataAddGraphInfo((GRAPHINFO *)data);
               return TRUE;
         case CopyDataTypes::ThreadInfo:
               CopyDataAddThreadInfo((THREADINFO *)data);
               return TRUE;
         default:
            ASSERT(FALSE);
            Log(new TraceFormatError(TraceEvent::None, IDS_BOGUS_COPYDATA_TYPE, pCopyDataStruct->dwData));
            return FALSE;
        } /* what kind of copydata */
    }

/****************************************************************************
*                         CaffinityDlg::OnRequestPlot
* Inputs:
*       WPARAM: ignored
*       LPARAM: (LPARAM)(HWND) the sending process
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Causes the process data to plot
****************************************************************************/

LRESULT CaffinityDlg::OnRequestPlot(WPARAM, LPARAM lParam)
    {
     for(INT_PTR i = 0; i < graphs.GetSize(); i++)
        { /* plot as appropriate */
         if(graphs[i]->GetProcess() == (HWND)lParam)
            graphs[i]->Plot();
        } /* plot as appropriate */
    return 0;
    } // CaffinityDlg::OnRequestPlot

/****************************************************************************
*                         CaffinityDlg::TryPlacement
* Inputs:
*       CRect r: Initial rectangle (only top,left considered)
*       const CRect & Screen: Screen bounding box
*       STARTUPINFO & startup:  Reference to startup info block to be filled in
* Result: BOOL
*       TRUE if the fit was good
*       FALSE if we overflowed the screen
* Effect: 
*       Computes the desired offset
****************************************************************************/

BOOL CaffinityDlg::TryPlacement(CRect r, const CRect & Screen, STARTUPINFO & startup)
    {
#define NEW_OFFSET (OffsetCount * (2 * ::GetSystemMetrics(SM_CYCAPTION)))
     r.left += NEW_OFFSET;
     r.top  += NEW_OFFSET;

     startup.dwX = r.left;
     startup.dwY = r.top;

     // Due to some other piece of egregious bogosity, if I try to set the
     // position as 0,0, the window will become CENTERED!  But if I set it
     // to 1, 1, it will appear in the top left corner!
     if(startup.dwX == 0)
        startup.dwX = 1;
     if(startup.dwY == 0)
        startup.dwY = 1;

     // This code is a bit oversimplified to implement a wraparound
     if((int)startup.dwX > Screen.right - (3 * NEW_OFFSET))
        { /* fell off right */
         return FALSE;
        } /* fell off right */

     if((int)startup.dwY > Screen.bottom - (3 * NEW_OFFSET))
        { /* fell off bottom */
         return FALSE;
        } /* fell off bottom */
     return TRUE;
    } // CaffinityDlg::TryPlacement

/****************************************************************************
*                       CaffinityDlg::OnBnClickedLaunch
* Result: void
*       
* Effect: 
*       Launches a secondary process
****************************************************************************/

void CaffinityDlg::OnBnClickedLaunch()
    {
     // Compute the bounding box of the screen.  This is a bit of a hack
     // and is not a complete solution; for example, it won't work with
     // monitors arranged with a gap in the bounding box, such as
     //         1  2    |  1    |  1    |  
     //            3    |    2  |  2  3 | ...etc.
     // and at the fringes where monitors have different resolutions and
     // coordinate systems it will also break down.

     // Note the error that the CreateProcess/STARTUPINFO dwX and dwY values
     // are DWORDs; this clearly predates the concept of monitors with
     // negative coordinates!
     CRect Screen;
     Screen.left = ::GetSystemMetrics(SM_XVIRTUALSCREEN);
     Screen.top  = ::GetSystemMetrics(SM_YVIRTUALSCREEN);
     Screen.right = Screen.left + ::GetSystemMetrics(SM_CXVIRTUALSCREEN);
     Screen.bottom = Screen.top + ::GetSystemMetrics(SM_CYVIRTUALSCREEN);

     CRect r;
     GetWindowRect(&r);  // get location on screen of master window

     OffsetCount++;

     STARTUPINFO startup = {sizeof(STARTUPINFO)};

     if(!TryPlacement(r, Screen, startup))
        { /* failed */
         r = Screen;
         OffsetCount = 0;
         VERIFY(TryPlacement(r, Screen, startup));  // should never fail!
        } /* failed */
     startup.dwFlags = STARTF_USEPOSITION;

     TCHAR me[MAX_PATH];
     ::GetModuleFileName(NULL, me, MAX_PATH);

     // Launch a new child process
     // Have the command line read
     //  /config:config /seq:n
     CString cmdline;
     cmdline.Format(_T("/config:%s /seq:%d"), GetConfiguration(), children.GetSize());
     LPTSTR cmdbuffer = cmdline.GetBuffer();

     PROCESS_INFORMATION process;

     if(!::CreateProcess(me,       // execution path
                         cmdbuffer,// /config:name /seq:name
                         NULL,     // process security
                         NULL,     // thread security
                         FALSE,    // inherit
                         0,        // flags
                         NULL,     // environment
                         NULL,     // working directory
                         &startup,
                         &process))
        { /* failed */
         DWORD err = ::GetLastError();
         cmdline.ReleaseBuffer();
         Log(new TraceFormatError(TraceEvent::None, IDS_CREATE_PROCESS_FAILED, me));
         Log(new TraceFormatMessage(TraceEvent::None, err));
         return;
        } /* failed */

     cmdline.ReleaseBuffer();

     Log(new TraceFormatComment(TraceEvent::None, IDS_CREATE_PROCESS_SUCCEEDED, process.dwThreadId));
     ::CloseHandle(process.hThread);
     ::CloseHandle(process.hProcess);
    }

/****************************************************************************
*                           CaffinityDlg::OnRunAll
* Inputs:
*       WPARAM: ignored
*       LRESULT: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Runs all the pending threads
****************************************************************************/

LRESULT CaffinityDlg::OnRunAll(WPARAM, LPARAM)
    {
     Log(new TraceComment(TraceEvent::None, IDS_UWM_RUN_ALL_RECEIVED));
     RunAllWaiting();
     return 0;
    } // CaffinityDlg::OnRunAll

/****************************************************************************
*                          CaffinityDlg::OnClickAll
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Creates all the threads
****************************************************************************/

LRESULT CaffinityDlg::OnClickAll(WPARAM, LPARAM)
    {
     // The "All" button has been clicked in the master controller
     //
     Log(new TraceComment(TraceEvent::None, IDS_UWM_CLICK_ALL_RECEIVED));

     for(int i = 0; i < MAX_THREADS; i++)
        ThreadInfo[i].OnGo();

     children.ResetAll();

     updateControls();
     SetupAllWaiting();
     Log(new TraceComment(TraceEvent::None, IDS_UWM_SETUP_COMPLETE_SENT));
     ::PostMessage(MasterController, UWM_SETUP_COMPLETE, 0, (LPARAM)m_hWnd);
     return 0;
    } // CaffinityDlg::OnClickAll

/****************************************************************************
*                        CaffinityDlg::OnSetupComplete
* Inputs:
*       WPARAM: ignored
*       LPARAM: (LPARAM)(HWND) window of affinity dialog
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       When all are complete, sends the UWM_RUN_ALL message
****************************************************************************/

LRESULT CaffinityDlg::OnSetupComplete(WPARAM, LPARAM lParam)
    {
     HWND child = (HWND)lParam;
     Log(new TraceFormatComment(TraceEvent::None, IDS_UWM_SETUP_COMPLETE_RECEIVED, child));
     // This works as follows:
     // it checks each entry in the child table
     // if the child is bogus, it is dismissed from the list (each child is checked, each time)
     // if all children are set up, issues the click message to all of them
     // otherwise it delays the startup

     children.Validate(this);

     // Mark the current one as set up
     children.MarkAsSetup(child);

     // Now, see if *everyone* is set up

     if(children.AllSetUp())
        { /* requesting RUN_ALL */
         Log(new TraceComment(TraceEvent::None, IDS_UWM_RUN_ALL_SENT));
         children.PostMessage(UWM_RUN_ALL, 0, 0);
        } /* requesting RUN_ALL */
     else
        { /* wait for more */
         Log(new TraceComment(TraceEvent::None, IDS_UWM_SETUP_COMPLETE_WAITING));
        } /* wait for more */
     return 0;
    } // CaffinityDlg::OnSetupComplete

/****************************************************************************
*                          CaffinityDlg::OnHelpAbout
* Result: void
*       
* Effect: 
*       Brings up the About dialog
****************************************************************************/

void CaffinityDlg::OnHelpAbout()
    {
     CAboutDlg dlgAbout;
     dlgAbout.DoModal();
    }

/****************************************************************************
*                          CaffinityDlg::OnFileExit
* Result: void
*       
* Effect: 
*       Exits the program
****************************************************************************/

void CaffinityDlg::OnFileExit()
    {
     PostMessage(WM_CLOSE);
    }

/****************************************************************************
*                           CaffinityDlg::OnLogSave
* Result: void
*       
* Effect: 
*       Saves the log.  Uses the filename of the last save, or prompts
*       if there has not previously been a save
****************************************************************************/

void CaffinityDlg::OnLogSave()
    {
     c_Log.Save();
    }

/****************************************************************************
*                          CaffinityDlg::OnLogSaveas
* Result: void
*       
* Effect: 
*       Saves the log with the option of another filename
****************************************************************************/

void CaffinityDlg::OnLogSaveas()
    {
     c_Log.SaveAs();
    }

/****************************************************************************
*                          CaffinityDlg::OnLogPrint
* Result: void
*       
* Effect: 
*       Prints the contents of the event log
****************************************************************************/

void CaffinityDlg::OnLogPrint()
    {
     c_Log.Print();
    }

/****************************************************************************
*                          CaffinityDlg::OnLogClear
* Result: void
*       
* Effect: 
*       Clears the contents of the event log
****************************************************************************/

void CaffinityDlg::OnLogClear()
    {
     c_Log.ResetContent();
    }

/****************************************************************************
*                        CaffinityDlg::OnInitMenuPopup
* Inputs:
*       CMenu * pPopupMenu: ignored
*       UINT nIndex: ignored
*       BOOL bSysMenu: ignored
* Result: void
*       
* Effect: 
*       Enables/disables menu items
****************************************************************************/

void CaffinityDlg::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu)
    {
     CDialog::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);

     pPopupMenu->EnableMenuItem(ID_LOG_CLEAR,          MF_BYCOMMAND | (c_Log.canClearAll()  ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_LOG_SAVE,           MF_BYCOMMAND | (c_Log.canSave()      ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_LOG_SAVEAS,         MF_BYCOMMAND | (c_Log.canSaveAs()    ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_LOG_PRINT,          MF_BYCOMMAND | (c_Log.canPrint()     ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_LOG_TOTOP,          MF_BYCOMMAND | (c_Log.canTop()       ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_LOG_TOEND,          MF_BYCOMMAND | (c_Log.canEnd()       ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_LOG_TONEXTERROR,    MF_BYCOMMAND | (c_Log.canNext()      ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_LOG_TOPREVIOUSERROR,MF_BYCOMMAND | (c_Log.canPrev()      ? MF_ENABLED : MF_GRAYED));

     pPopupMenu->EnableMenuItem(ID_EDIT_COPY,          MF_BYCOMMAND | (c_Log.canCopy()      ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_EDIT_CUT,           MF_BYCOMMAND | (c_Log.canCut()       ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_EDIT_SELECTALL,     MF_BYCOMMAND | (c_Log.canSelectAll() ? MF_ENABLED : MF_GRAYED));
     pPopupMenu->EnableMenuItem(ID_EDIT_DELETE,        MF_BYCOMMAND | (c_Log.canDelete()    ? MF_ENABLED : MF_GRAYED));
    }

/****************************************************************************
*                          CaffinityDlg::OnEditCopy
* Result: void
*       
* Effect: 
*       Copies selected items in the log to the clipboard
****************************************************************************/

void CaffinityDlg::OnEditCopy()
    {
     c_Log.Copy();
    }

void CaffinityDlg::OnEditCut()
    {
     c_Log.Cut();
    }

void CaffinityDlg::OnEditDelete()
    {
     c_Log.Delete();
    }

void CaffinityDlg::OnEditSelectall()
    {
     c_Log.SelectAll();
    }

void CaffinityDlg::OnLogToTop()
    {
     c_Log.toTop();
    }

void CaffinityDlg::OnLogToNextError()
    {
     c_Log.toNext();
    }

void CaffinityDlg::OnLogToPreviousError()
    {
     c_Log.toPrev();
    }

void CaffinityDlg::OnLogToEnd()
    {
     c_Log.toEnd();
    }

/****************************************************************************
*                         CaffinityDlg::OnLogSetfont
* Result: void
*       
* Effect: 
*       Brings up a dialog to select a printer font, then saves the
*       font information
****************************************************************************/

void CaffinityDlg::OnLogSetfont()
    {
     if(c_Log.RequestFont())
        { /* selected font */
         //**********************
         // Printer font (global)
         //**********************
         RegistryFont f(IDS_REGISTRY_PRINTER_FONT);
         c_Log.GetPrinterLogFont(&f.value);
         VERIFY(f.store());
        } /* selected font */
    }

/****************************************************************************
*                 CaffinityDlg::OnBnClickedCopyPrioirtyClass
* Result: void
*       
* Effect: 
*       Copies the
*
* Priority Class: [class name ][v] 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
*
* pixels to the clipboard so they can be used to create illustrations on the
* web page
****************************************************************************/

void CaffinityDlg::OnBnClickedCopyPriorityClass()
    {
     toClipboard(&c_PriorityCopyFrame);
    }

/****************************************************************************
*                    CaffinityDlg::OnBnClickedCopyProgress
* Result: void
*       
* Effect: 
*       Copies the progress bars to the clipboard for the Web page articles
****************************************************************************/

void CaffinityDlg::OnBnClickedCopyProgress()
    {
     toClipboard(&c_CopyProgressFrame);
    }

/****************************************************************************
*                     CaffinityDlg::WatchConfigurationKey
* Inputs:
*       LPVOID p:
* Result: UINT
*       0, always
* Effect: 
*       Watches the IDS_PROGRAM_ROOT\IDS_REGISTRY_KEY_CONFIGURATIONS key
*       for changes
****************************************************************************/

/* static */ UINT CaffinityDlg::WatchConfigurationKey(LPVOID p)
    {
     CaffinityDlg * self = (CaffinityDlg *)p;
     
     HANDLE changeEvent = ::CreateEvent(NULL, TRUE, FALSE, NULL); // notification of change event
     if(changeEvent == NULL)
        { /* failed */
         DWORD err = ::GetLastError();
         self->Log(new TraceError(TraceEvent::None, IDS_NOTIFICATION_EVENT_FAILED));
         self->Log(new TraceFormatMessage(TraceEvent::None, err));
         return 0;
        } /* failed */
     self->DoWatch(changeEvent);
     ::CloseHandle(changeEvent);
     return 0;
    } // CaffinityDlg::WatchConfigurationKey
     

/****************************************************************************
*                            CaffinityDlg::DoWatch
* Inputs:
*       HANDLE changeEvent: event that will become signaled when the key changes
* Result: void
*       
* Effect: 
*       Opens a key and watches it
* Notes:
*       This watches the HKEY_CURRENT_USER\IDS_REGISTRY_CONFIGURATIONS key
****************************************************************************/

void CaffinityDlg::DoWatch(HANDLE changeEvent)
    {
     CString config;
     config.LoadString(IDS_REGISTRY_CONFIGURATIONS);

     if(!CreateKey(HKEY_CURRENT_USER, config, KEY_NOTIFY))
        { /* creation failed */
         DWORD err = ::GetLastError();
         ASSERT(FALSE);
         Log(new TraceFormatError(TraceEvent::None, IDS_NOTIFICATION_CREATE_FAILED, config));
         Log(new TraceFormatMessage(TraceEvent::None, err));
         return;
        } /* creation failed */

     HKEY key;
     key = OpenKey(HKEY_CURRENT_USER, config);
     if(key == NULL)
        { /* failed */
         DWORD err = ::GetLastError();
         ASSERT(FALSE);
         Log(new TraceFormatError(TraceEvent::None, IDS_NOTIFICATION_OPEN_FAILED, config));
         Log(new TraceFormatMessage(TraceEvent::None, err));
         return;
        } /* failed */

         
     HANDLE waiters[2];
     waiters[0] = StopWatchEvent; // system shutdown event
     waiters[1] = changeEvent;    // key change event

     BOOL running = TRUE;
     while(running)
        { /* watch key change */
         LONG result = ::RegNotifyChangeKeyValue(key,
                                                 FALSE, // watch subtree
                                                 REG_NOTIFY_CHANGE_NAME,
                                                 changeEvent,
                                                 TRUE); // return immediately, asynchronous
         if(result != ERROR_SUCCESS)
            { /* watch failed */
             DWORD err = ::GetLastError();
             Log(new TraceFormatError(TraceEvent::None, IDS_REGNOTIFYCHANGEVALUE_FAILED, config));
             Log(new TraceFormatMessage(TraceEvent::None, err));
            } /* watch failed */

         switch(::WaitForMultipleObjects(2, waiters, FALSE, INFINITE))
            { /* wait */
             case WAIT_TIMEOUT:
                ASSERT(FALSE); // not currently used
                running = FALSE;
                continue;
             case WAIT_OBJECT_0:     // permanent shutdown
                // We are being asked to shut down
                running = FALSE;
                continue;
             case WAIT_OBJECT_0 + 1: // key changed
                PostMessage(UWM_CONFIGURATION_CHANGE);
                continue;
            } /* wait */
        } /* watch key change */
     ::RegCloseKey(key);
    } // CaffinityDlg::DoWatch 

/****************************************************************************
*                     CaffinityDlg::OnConfigurationChange
* Inputs:
*       WPARAM: ignored
*       LPARAM: ignored
* Result: LRESULT
*       Logically void, 0, always
* Effect: 
*       Handles the fact that a configuration has been added or deleted
****************************************************************************/

LRESULT CaffinityDlg::OnConfigurationChange(WPARAM, LPARAM)
    {
     Log(new TraceComment(TraceEvent::None, IDS_SAW_REGISTRY_CHANGE));
     return 0;
    } // CaffinityDlg::OnConfigurationChange

/****************************************************************************
*                         CaffinityDlg::OnToolTipNotify
* Inputs:
*       UINT id: ID of control
*       NMHDR * pNMHDR: notification header
*       LRESULT * pResult: Set to 0, always
* Result: BOO
*       TRUE if message was handled
* Effect: 
*       Provides text to tooltips
****************************************************************************/

BOOL CaffinityDlg::OnToolTipNotify(UINT id, NMHDR * pNMHDR, LRESULT * pResult)
    {
     TOOLTIPTEXT * pTTT = (TOOLTIPTEXT *)pNMHDR;
     UINT_PTR nID = pNMHDR->idFrom;

     CString text;
     
     if (pNMHDR->code == TTN_NEEDTEXT && (pTTT->uFlags & TTF_IDISHWND))
        {
         // idFrom is actually the HWND of the tool
         nID = ::GetDlgCtrlID((HWND)nID);
        }

     switch(nID)
        { /* decode text */
         case 0:
            *pResult = 0;
            return FALSE;
         default:
            pTTT->lpszText = MAKEINTRESOURCE(nID);
            pTTT->hinst = AfxGetInstanceHandle();
            break;
        } /* decode text */

     *pResult = 0;

     return TRUE;
    } // CaffinityDlg::OnToolTipNotify
